import { Component, Inject, forwardRef, NgModule, ViewEncapsulation } from '@angular/core';
import { OLightTableComponent } from './o-light-table.component';
import { OSharedModule } from 'ontimize-web-ng2';
import { CommonModule } from '@angular/common';
var OLightTableButtonPanelComponent = (function () {
    function OLightTableButtonPanelComponent(table) {
        this.table = table;
    }
    OLightTableButtonPanelComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-light-table-button-panel',
                    template: "\n    <md-toolbar class=\"o-light-table-button-panel\">\n      <div class=\"mat-toolbar-tools\" *ngIf=\"!table.deleting\">\n        <span fxFlex></span>\n        <button type=\"button\" md-icon-button (click)=\"table.filter($event)\">\n          <md-icon aria-label=\"Filter items\">filter_list</md-icon>\n        </button>\n        <button type=\"button\" id=\"removeButton\" md-icon-button (click)=\"table.remove($event)\">\n          <md-icon aria-label=\"Select items to delete\">delete</md-icon>\n        </button>\n        <button type=\"button\" md-icon-button (click)=\"table.add($event)\" >\n          <md-icon aria-label=\"New item\">add</md-icon>\n        </button>\n      </div>\n\n      <div class=\"mat-toolbar-tools\" *ngIf=\"table.deleting\">\n        <button  type=\"button\" md-icon-button (click)=\"table.cancelRemove($event)\">\n          <md-icon aria-label=\"Cancel selection of items to delete\">clear</md-icon>\n        </button>\n        <span fxFlex></span>\n        <button type=\"button\" md-icon-button (click)=\"table.remove($event)\">\n          <md-icon aria-label=\"Delete selected items\">done</md-icon>\n        </button>\n      </div>\n    </md-toolbar>\n  ",
                    styles: ["\n    md-toolbar.o-light-table-button-panel{background-color:#eee;color:rgba(0,0,0,0.87);border-top:1px solid #fff;border-bottom:1px solid #fff;overflow:initial}md-toolbar.o-light-table-button-panel p{font-size:small}md-toolbar.o-light-table-button-panel [md-button].mat-icon-button{color:rgba(0,0,0,0.87)}\n  "],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    OLightTableButtonPanelComponent.ctorParameters = function () { return [
        { type: OLightTableComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return OLightTableComponent; }),] },] },
    ]; };
    return OLightTableButtonPanelComponent;
}());
export { OLightTableButtonPanelComponent };
var OLightTableButtonPanelModule = (function () {
    function OLightTableButtonPanelModule() {
    }
    OLightTableButtonPanelModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [OLightTableButtonPanelComponent],
                    imports: [OSharedModule, CommonModule],
                    exports: [OLightTableButtonPanelComponent],
                },] },
    ];
    OLightTableButtonPanelModule.ctorParameters = function () { return []; };
    return OLightTableButtonPanelModule;
}());
export { OLightTableButtonPanelModule };
//# sourceMappingURL=o-light-table-button-panel.component.js.map