import { Component, Inject, Injector, forwardRef, NgModule, ViewEncapsulation } from '@angular/core';
import { MomentService, OSharedModule } from 'ontimize-web-ng2';
import { OLightTableComponent } from './o-light-table.component';
import { CommonModule } from '@angular/common';
export var DEFAULT_INPUTS_O_LIGHT_TABLE_COLUMN = [
    'id',
    'title',
    'otype: type',
    'format',
    'pipe',
    'flex'
];
export var DEFAULT_OUTPUTS_O_LIGHT_TABLE_COLUMN = [];
var OLightTableColumnComponent = (function () {
    function OLightTableColumnComponent(_table, injector) {
        this.injector = injector;
        this.title = '';
        this.otype = 'text';
        this.momentSrv = injector.get(MomentService);
        this._table = _table;
    }
    OLightTableColumnComponent.prototype.ngOnInit = function () {
        this._table.registerColumn(this);
    };
    OLightTableColumnComponent.prototype.getId = function () {
        return this.id;
    };
    OLightTableColumnComponent.prototype.getRenderedValue = function (value) {
        if (value) {
            switch (this.otype) {
                case OLightTableColumnComponent.DATE_TYPE:
                    value = this.parseDate(value);
                    break;
                default: break;
            }
        }
        return value;
    };
    OLightTableColumnComponent.prototype.parseDate = function (value) {
        var result = '';
        result = this.momentSrv.parseDate(value, this.format);
        return result;
    };
    OLightTableColumnComponent.DEFAULT_INPUTS_O_LIGHT_TABLE_COLUMN = DEFAULT_INPUTS_O_LIGHT_TABLE_COLUMN;
    OLightTableColumnComponent.DEFAULT_OUTPUTS_O_LIGHT_TABLE_COLUMN = DEFAULT_OUTPUTS_O_LIGHT_TABLE_COLUMN;
    OLightTableColumnComponent.DATE_TYPE = 'date';
    OLightTableColumnComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-light-table-column',
                    template: "\n\n  ",
                    styles: ["\n\n  "],
                    inputs: DEFAULT_INPUTS_O_LIGHT_TABLE_COLUMN.slice(),
                    outputs: DEFAULT_OUTPUTS_O_LIGHT_TABLE_COLUMN.slice(),
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    OLightTableColumnComponent.ctorParameters = function () { return [
        { type: OLightTableComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return OLightTableComponent; }),] },] },
        { type: Injector, },
    ]; };
    return OLightTableColumnComponent;
}());
export { OLightTableColumnComponent };
var OLightTableColumnModule = (function () {
    function OLightTableColumnModule() {
    }
    OLightTableColumnModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [OLightTableColumnComponent],
                    imports: [OSharedModule, CommonModule],
                    exports: [OLightTableColumnComponent],
                },] },
    ];
    OLightTableColumnModule.ctorParameters = function () { return []; };
    return OLightTableColumnModule;
}());
export { OLightTableColumnModule };
//# sourceMappingURL=o-light-table-column.component.js.map