import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { MdDialogRef } from '@angular/material';
var ODataTableCellEditorDateDialog = (function () {
    function ODataTableCellEditorDateDialog(dialogRef) {
        this.dialogRef = dialogRef;
    }
    ODataTableCellEditorDateDialog.prototype.initialize = function (parameters) {
        this.date = parameters['data'];
        this.label = parameters['label'];
    };
    ODataTableCellEditorDateDialog.prototype.ngAfterViewInit = function () {
        if (this.form) {
            this.form.setInsertMode();
        }
    };
    ODataTableCellEditorDateDialog.prototype.getDateValue = function () {
        if (this.form) {
            return this.form.getDataValue('dateInput').value;
        }
        return undefined;
    };
    Object.defineProperty(ODataTableCellEditorDateDialog.prototype, "date", {
        get: function () {
            return this._date;
        },
        set: function (val) {
            this._date = val instanceof Date ? val : new Date(val);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ODataTableCellEditorDateDialog.prototype, "label", {
        get: function () {
            return this._label;
        },
        set: function (val) {
            this._label = val;
        },
        enumerable: true,
        configurable: true
    });
    ODataTableCellEditorDateDialog.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-cell-editor-date-dialog',
                    template: "\n    <h2 md-dialog-title>{{ 'TABLE.SELECT_DATE' | oTranslate }}</h2>\n    <md-dialog-content>\n      <o-form #form show-header=\"no\" style=\"height: 120px;\">\n        <o-date-input attr=\"dateInput\" [label]=\"label\" layout-padding [data]=\"date\" required=\"true\"></o-date-input>\n      </o-form>\n    </md-dialog-content>\n    <md-dialog-actions>\n      <button md-button class=\"mat-primary\" [md-dialog-close]=\"getDateValue()\">\n        <span>{{ 'ACCEPT' | oTranslate | uppercase }}</span>\n      </button>\n      <button md-button class=\"mat-primary\" [md-dialog-close]=\"undefined\">\n        <span>{{ 'CANCEL' | oTranslate | uppercase }}</span>\n      </button>\n    </md-dialog-actions>\n  ",
                    styles: ["\n\n  "],
                    inputs: [
                        'data',
                        'label'
                    ],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    ODataTableCellEditorDateDialog.ctorParameters = function () { return [
        { type: MdDialogRef, },
    ]; };
    ODataTableCellEditorDateDialog.propDecorators = {
        'form': [{ type: ViewChild, args: ['form',] },],
    };
    return ODataTableCellEditorDateDialog;
}());
export { ODataTableCellEditorDateDialog };
//# sourceMappingURL=o-datatable-cell-editor-date-dialog.component.js.map