import { Component, Inject, Injector, forwardRef } from '@angular/core';
import { OTranslateService } from 'ontimize-web-ng2';
import { ODataTableColumnComponent } from '../o-datatable-column.component';
export var DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_BOOLEAN = [
    'trueValueType: true-value-type',
    'trueValue: true-value',
    'falseValueType: false-value-type',
    'falseValue: false-value',
    'dataType: data-type'
];
var ODataTableCellRendererBooleanComponent = (function () {
    function ODataTableCellRendererBooleanComponent(tableColumn, injector) {
        this.injector = injector;
        tableColumn.registerRenderer(this);
        this.translateService = this.injector.get(OTranslateService);
    }
    ODataTableCellRendererBooleanComponent.prototype.init = function (parameters) {
        if (typeof (parameters) !== 'undefined') {
            if (typeof (parameters.trueValueType) !== 'undefined') {
                this.trueValueType = parameters.trueValueType;
            }
            if (typeof (parameters.trueValue) !== 'undefined') {
                this.trueValue = parameters.trueValue;
            }
            if (typeof (parameters.falseValueType) !== 'undefined') {
                this.falseValueType = parameters.falseValueType;
            }
            if (typeof (parameters.falseValue) !== 'undefined') {
                this.falseValue = parameters.falseValue;
            }
            if (typeof (parameters.dataType) !== 'undefined') {
                this.dataType = parameters.dataType;
            }
        }
    };
    ODataTableCellRendererBooleanComponent.prototype.render = function (cellData, rowData) {
        return (this.hasCellDataTrueValue(cellData)) ?
            this.generateTemplate(this.trueValue, this.trueValueType) :
            this.generateTemplate(this.falseValue, this.falseValueType);
    };
    ODataTableCellRendererBooleanComponent.prototype.handleCreatedCell = function (cellElement, rowData) {
    };
    ODataTableCellRendererBooleanComponent.prototype.generateTemplate = function (value, type) {
        var template = '';
        switch (type) {
            case 'string':
                template = this.translateService.get(value);
                break;
            case 'number':
                template = value;
                break;
            case 'icon':
                template = '<md-icon class="material-icons">' + value + '</md-icon>';
                break;
            case 'image':
                template = '<img src="' + value + '" />';
                break;
        }
        return template;
    };
    ODataTableCellRendererBooleanComponent.prototype.hasCellDataTrueValue = function (cellData) {
        var comparisonValue = undefined;
        switch (this.dataType) {
            case 'string':
                var stringVal = cellData.toString().toLowerCase();
                comparisonValue = (stringVal === 'true' || stringVal === 'yes');
                break;
            case 'number':
                comparisonValue = (cellData === 1);
                break;
            case 'boolean':
            case 'default':
                comparisonValue = (cellData === true);
                break;
        }
        return comparisonValue;
    };
    ODataTableCellRendererBooleanComponent.DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_BOOLEAN = DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_BOOLEAN;
    ODataTableCellRendererBooleanComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-cell-renderer-boolean',
                    template: '',
                    inputs: DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_BOOLEAN.slice()
                },] },
    ];
    ODataTableCellRendererBooleanComponent.ctorParameters = function () { return [
        { type: ODataTableColumnComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ODataTableColumnComponent; }),] },] },
        { type: Injector, },
    ]; };
    return ODataTableCellRendererBooleanComponent;
}());
export { ODataTableCellRendererBooleanComponent };
//# sourceMappingURL=o-datatable-cell-renderer-boolean.component.js.map