var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Injector, forwardRef } from '@angular/core';
import { ODataTableCellRendererRealComponent, DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_REAL } from './o-datatable-cell-renderer-real.component';
import { ODataTableColumnComponent } from '../o-datatable-column.component';
import { CurrencyService } from 'ontimize-web-ng2';
export var DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_CURRENCY = DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_REAL.concat([
    'currencySymbol: currency-symbol',
    'currencySymbolPosition: currency-symbol-position'
]);
var ODataTableCellRendererCurrencyComponent = (function (_super) {
    __extends(ODataTableCellRendererCurrencyComponent, _super);
    function ODataTableCellRendererCurrencyComponent(tableColumn, injector) {
        var _this = _super.call(this, tableColumn, injector) || this;
        _this.injector = injector;
        _this.currencyService = _this.injector.get(CurrencyService);
        return _this;
    }
    ODataTableCellRendererCurrencyComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.tableColumn.updateRendererType('currency');
        if (typeof (this.currencySymbol) === 'undefined') {
            this.currencySymbol = this.currencyService.symbol;
        }
        if (typeof (this.currencySymbolPosition) === 'undefined') {
            this.currencySymbolPosition = this.currencyService.symbolPosition;
        }
    };
    ODataTableCellRendererCurrencyComponent.prototype.init = function (parameters) {
        _super.prototype.init.call(this, parameters);
        if (typeof (parameters) !== 'undefined') {
            if (typeof (parameters.currencySymbol) !== 'undefined') {
                this.currencySymbol = parameters.currencySymbol;
            }
            if (typeof (parameters.currencySymbolPosition) !== 'undefined') {
                this.currencySymbolPosition = parameters.currencySymbolPosition;
            }
        }
    };
    ODataTableCellRendererCurrencyComponent.prototype.render = function (cellData, rowData) {
        var value = this.currencyService.getCurrencyValue(cellData, this.currencySymbol, this.currencySymbolPosition, this.grouping, this.thousandSeparator, this.decimalSeparator, this.decimalDigits);
        return '<div o-number-value="' + ((typeof (cellData) !== 'undefined') ? cellData : 0) + '">' +
            value +
            '</div>';
    };
    ODataTableCellRendererCurrencyComponent.prototype.handleCreatedCell = function (cellElement, rowData) {
    };
    ODataTableCellRendererCurrencyComponent.DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_CURRENCY = DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_CURRENCY;
    ODataTableCellRendererCurrencyComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-cell-renderer-currency',
                    template: '',
                    inputs: DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_CURRENCY.slice()
                },] },
    ];
    ODataTableCellRendererCurrencyComponent.ctorParameters = function () { return [
        { type: ODataTableColumnComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ODataTableColumnComponent; }),] },] },
        { type: Injector, },
    ]; };
    return ODataTableCellRendererCurrencyComponent;
}(ODataTableCellRendererRealComponent));
export { ODataTableCellRendererCurrencyComponent };
//# sourceMappingURL=o-datatable-cell-renderer-currency.component.js.map