import { Component, Inject, Injector, forwardRef } from '@angular/core';
import { MomentService } from 'ontimize-web-ng2';
import { ODataTableColumnComponent } from '../o-datatable-column.component';
export var DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_DATE = [
    'format'
];
var ODataTableCellRendererDateComponent = (function () {
    function ODataTableCellRendererDateComponent(tableColumn, injector) {
        this.tableColumn = tableColumn;
        this.injector = injector;
        tableColumn.registerRenderer(this);
        this.momentService = this.injector.get(MomentService);
    }
    ODataTableCellRendererDateComponent.prototype.ngOnInit = function () {
        this.tableColumn.updateRendererType('date');
    };
    ODataTableCellRendererDateComponent.prototype.init = function (parameters) {
        if (typeof (parameters) !== 'undefined') {
            if (typeof (parameters.format) !== 'undefined') {
                this.format = parameters.format;
            }
        }
    };
    ODataTableCellRendererDateComponent.prototype.render = function (cellData, rowData) {
        return '<div o-timestamp-value="' + ((typeof (cellData) !== 'undefined') ? cellData : 0) + '">' +
            ((typeof (cellData) !== 'undefined') ? this.momentService.parseDate(cellData, this.format) : '') +
            '</div>';
    };
    ODataTableCellRendererDateComponent.prototype.handleCreatedCell = function (cellElement, rowData) {
    };
    ODataTableCellRendererDateComponent.DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_DATE = DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_DATE;
    ODataTableCellRendererDateComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-cell-renderer-date',
                    template: '',
                    inputs: DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_DATE.slice()
                },] },
    ];
    ODataTableCellRendererDateComponent.ctorParameters = function () { return [
        { type: ODataTableColumnComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ODataTableColumnComponent; }),] },] },
        { type: Injector, },
    ]; };
    return ODataTableCellRendererDateComponent;
}());
export { ODataTableCellRendererDateComponent };
//# sourceMappingURL=o-datatable-cell-renderer-date.component.js.map