import { Component, Inject, Injector, forwardRef } from '@angular/core';
import { NumberService, Util } from 'ontimize-web-ng2';
import { ODataTableColumnComponent } from '../o-datatable-column.component';
export var DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_INTEGER = [
    'grouping',
    'thousandSeparator: thousand-separator'
];
var ODataTableCellRendererIntegerComponent = (function () {
    function ODataTableCellRendererIntegerComponent(tableColumn, injector) {
        this.tableColumn = tableColumn;
        this.injector = injector;
        tableColumn.registerRenderer(this);
        this.numberService = this.injector.get(NumberService);
    }
    ODataTableCellRendererIntegerComponent.prototype.ngOnInit = function () {
        this.grouping = Util.parseBoolean(this.grouping, true);
        this.tableColumn.updateRendererType('integer');
    };
    ODataTableCellRendererIntegerComponent.prototype.init = function (parameters) {
        if (typeof (parameters) !== 'undefined') {
            if (typeof (parameters.grouping) !== 'undefined') {
                this.grouping = parameters.grouping;
            }
            if (typeof (parameters.thousandSeparator) !== 'undefined') {
                this.thousandSeparator = parameters.thousandSeparator;
            }
        }
    };
    ODataTableCellRendererIntegerComponent.prototype.render = function (cellData, rowData) {
        return '<div o-number-value="' + ((typeof (cellData) !== 'undefined') ? cellData : 0) + '">' +
            this.numberService.getIntegerValue(cellData, this.grouping, this.thousandSeparator) +
            '</div>';
    };
    ODataTableCellRendererIntegerComponent.prototype.handleCreatedCell = function (cellElement, rowData) {
    };
    ODataTableCellRendererIntegerComponent.DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_INTEGER = DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_INTEGER;
    ODataTableCellRendererIntegerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-cell-renderer-integer',
                    template: '',
                    inputs: DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_INTEGER.slice()
                },] },
    ];
    ODataTableCellRendererIntegerComponent.ctorParameters = function () { return [
        { type: ODataTableColumnComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ODataTableColumnComponent; }),] },] },
        { type: Injector, },
    ]; };
    return ODataTableCellRendererIntegerComponent;
}());
export { ODataTableCellRendererIntegerComponent };
//# sourceMappingURL=o-datatable-cell-renderer-integer.component.js.map