import * as $ from 'jquery';
import { Component, Inject, Injector, forwardRef } from '@angular/core';
import { OntimizeService, dataServiceFactory, Util } from 'ontimize-web-ng2';
import { ODataTableColumnComponent } from '../o-datatable-column.component';
import { ODataTableComponent } from '../o-datatable.component';
export var DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_SERVICE = [
    'service',
    'queryMethod: query-method',
    'entity',
    'valueColumn: value-column',
    'columns',
    'visibleColumns: visible-columns',
    'separator'
];
var ODataTableCellRendererServiceComponent = (function () {
    function ODataTableCellRendererServiceComponent(tableColumn, injector) {
        this.tableColumn = tableColumn;
        this.injector = injector;
        tableColumn.registerRenderer(this);
        this.componentData = {};
    }
    ODataTableCellRendererServiceComponent.prototype.ngOnInit = function () {
        this.tableColumn.updateRendererType('service');
        if (typeof (this.separator) === 'undefined') {
            this.separator = '';
        }
        if (typeof (this.queryMethod) === 'undefined') {
            this.queryMethod = 'query';
        }
        this.init(undefined);
    };
    ODataTableCellRendererServiceComponent.prototype.init = function (parameters) {
        var _this = this;
        if (typeof (parameters) !== 'undefined') {
            if (typeof (parameters.service) !== 'undefined') {
                this.service = parameters.service;
            }
            if (typeof (parameters.entity) !== 'undefined') {
                this.entity = parameters.entity;
            }
            if (typeof (parameters.valueColumn) !== 'undefined') {
                this.valueColumn = parameters.valueColumn;
            }
            if (typeof (parameters.columns) !== 'undefined') {
                this.columns = parameters.columns;
            }
            if (typeof (parameters.visibleColumns) !== 'undefined') {
                this.visibleColumns = parameters.visibleColumns;
            }
            if (typeof (parameters.separator) !== 'undefined') {
                this.separator = parameters.separator;
            }
            if (typeof (parameters.queryMethod) !== 'undefined') {
                this.queryMethod = parameters.queryMethod;
            }
        }
        if (this.columns) {
            this.dataColumns = this.columns.split(ODataTableComponent.COLUMNS_SEPARATOR);
        }
        else {
            this.dataColumns = [];
        }
        if (this.visibleColumns) {
            this.dataVisibleColumns = this.visibleColumns.split(ODataTableComponent.COLUMNS_SEPARATOR);
        }
        else {
            this.dataVisibleColumns = [];
        }
        this.dataService = this.injector.get(OntimizeService);
        if (Util.isDataService(this.dataService)) {
            var serviceCfg = this.dataService.getDefaultServiceConfiguration(this.service);
            if (this.entity) {
                serviceCfg['entity'] = this.entity;
            }
            this.dataService.configureService(serviceCfg);
        }
        if (this.dataService && (this.queryMethod in this.dataService) && this.entity && this.valueColumn) {
            this.dataService[this.queryMethod]({}, this.dataColumns, this.entity).subscribe(function (res) {
                var data = undefined;
                if ($.isArray(res)) {
                    data = res;
                }
                else if ((res.code === 0) && $.isArray(res.data)) {
                    data = res.data;
                }
                if ($.isArray(data)) {
                    for (var i = 0; i < data.length; ++i) {
                        var item = data[i];
                        var key = item[_this.valueColumn];
                        if (typeof (key) !== 'undefined') {
                            var value = '';
                            for (var j = 0; j < _this.dataVisibleColumns.length; ++j) {
                                var col = _this.dataVisibleColumns[j];
                                if (typeof (item[col]) !== 'undefined') {
                                    if (j > 0) {
                                        value += _this.separator;
                                    }
                                    value += String(item[col]);
                                }
                            }
                            _this.componentData[key] = value;
                        }
                    }
                }
                else {
                    console.log('[ODataTableCellRendererServiceComponent.init]: error code ' + res.code + ' when querying data');
                }
            }, function (err) {
                console.log('[ODataTableCellRendererServiceComponent.init]: error', err);
            });
        }
    };
    ODataTableCellRendererServiceComponent.prototype.render = function (data) {
        return (typeof (this.componentData[data]) !== 'undefined') ? String(this.componentData[data]) : '';
    };
    ODataTableCellRendererServiceComponent.prototype.handleCreatedCell = function (cellElement, rowData) {
    };
    ODataTableCellRendererServiceComponent.DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_SERVICE = DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_SERVICE;
    ODataTableCellRendererServiceComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-cell-renderer-service',
                    template: '',
                    inputs: DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_SERVICE.slice(),
                    providers: [
                        { provide: OntimizeService, useFactory: dataServiceFactory, deps: [Injector] }
                    ]
                },] },
    ];
    ODataTableCellRendererServiceComponent.ctorParameters = function () { return [
        { type: ODataTableColumnComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ODataTableColumnComponent; }),] },] },
        { type: Injector, },
    ]; };
    return ODataTableCellRendererServiceComponent;
}());
export { ODataTableCellRendererServiceComponent };
//# sourceMappingURL=o-datatable-cell-renderer-service.component.js.map