import { Component, Inject, forwardRef, Injector } from '@angular/core';
import { ODataTableColumnComponent } from '../o-datatable-column.component';
import { OTranslateService, Util } from 'ontimize-web-ng2';
export var DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_STRING = [
    'translate'
];
var ODataTableCellRendererStringComponent = (function () {
    function ODataTableCellRendererStringComponent(tableColumn, injector) {
        this.tableColumn = tableColumn;
        this.injector = injector;
        tableColumn.registerRenderer(this);
        this.translateService = this.injector.get(OTranslateService);
    }
    ODataTableCellRendererStringComponent.prototype.ngOnInit = function () {
        this.tableColumn.updateRendererType('string');
        this.translate = Util.parseBoolean(this.translate, false);
        this.init(undefined);
    };
    ODataTableCellRendererStringComponent.prototype.init = function (parameters) {
        if (typeof (parameters) !== 'undefined') {
            if (typeof (parameters.translate) !== 'undefined') {
                this.translate = parameters.translate;
            }
        }
    };
    ODataTableCellRendererStringComponent.prototype.render = function (cellData, rowData) {
        var value = '';
        if (typeof (cellData) !== 'undefined') {
            value = this.translate ? this.translateService.get(String(cellData)) : String(cellData);
        }
        return value;
    };
    ODataTableCellRendererStringComponent.prototype.handleCreatedCell = function (cellElement, rowData) {
    };
    ODataTableCellRendererStringComponent.DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_STRING = DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_STRING;
    ODataTableCellRendererStringComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-cell-renderer-string',
                    template: '',
                    inputs: DEFAULT_INPUTS_O_DATATABLE_CELL_RENDERER_STRING.slice(),
                },] },
    ];
    ODataTableCellRendererStringComponent.ctorParameters = function () { return [
        { type: ODataTableColumnComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ODataTableColumnComponent; }),] },] },
        { type: Injector, },
    ]; };
    return ODataTableCellRendererStringComponent;
}());
export { ODataTableCellRendererStringComponent };
//# sourceMappingURL=o-datatable-cell-renderer-string.component.js.map