import { Component, Inject, forwardRef, EventEmitter, Injector } from '@angular/core';
import { OTranslateService } from 'ontimize-web-ng2';
import { ODataTableComponent } from '../o-datatable.component';
export var DEFAULT_INPUTS_O_DATATABLE_BUTTON = [
    'icon',
    'olabel: label'
];
export var DEFAULT_OUTPUTS_O_DATATABLE_BUTTON = [
    'onClick'
];
var ODataTableButtonComponent = (function () {
    function ODataTableButtonComponent(injector, table) {
        this.injector = injector;
        this.onClick = new EventEmitter();
        this.table = table;
        this.translateService = injector.get(OTranslateService);
    }
    ODataTableButtonComponent.prototype.ngOnInit = function () {
        this.table.registerHeaderButton(this);
        if (typeof this.olabel !== 'undefined' && this.olabel.length > 0) {
            this.olabel = this.translateService.get(this.olabel);
        }
        if (typeof this.icon === 'undefined') {
            this.icon = 'priority_high';
        }
    };
    ODataTableButtonComponent.prototype.getLabel = function () {
        return this.olabel;
    };
    ODataTableButtonComponent.prototype.getIcon = function () {
        return this.icon;
    };
    ODataTableButtonComponent.prototype.innerOnClick = function () {
        this.onClick.emit();
    };
    ODataTableButtonComponent.DEFAULT_INPUTS_O_DATATABLE_BUTTON = DEFAULT_INPUTS_O_DATATABLE_BUTTON;
    ODataTableButtonComponent.DEFAULT_OUTPUTS_O_DATATABLE_BUTTON = DEFAULT_OUTPUTS_O_DATATABLE_BUTTON;
    ODataTableButtonComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-button',
                    template: '',
                    inputs: DEFAULT_INPUTS_O_DATATABLE_BUTTON.slice(),
                    outputs: DEFAULT_OUTPUTS_O_DATATABLE_BUTTON.slice()
                },] },
    ];
    ODataTableButtonComponent.ctorParameters = function () { return [
        { type: Injector, },
        { type: ODataTableComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ODataTableComponent; }),] },] },
    ]; };
    return ODataTableButtonComponent;
}());
export { ODataTableButtonComponent };
//# sourceMappingURL=o-datatable-button.component.js.map