import { Component, Inject, forwardRef, EventEmitter } from '@angular/core';
import { ODataTableComponent } from '../o-datatable.component';
export var DEFAULT_INPUTS_O_DATATABLE_OPTION = [
    'icon',
    'olabel: label',
    'iconPosition: icon-position'
];
export var DEFAULT_OUTPUTS_O_DATATABLE_OPTION = [
    'onClick'
];
var ODataTableOptionComponent = (function () {
    function ODataTableOptionComponent(table) {
        this.onClick = new EventEmitter();
        this.table = table;
    }
    ODataTableOptionComponent.prototype.ngOnInit = function () {
        this.table.registerHeaderOption(this);
        if (this.iconPosition === undefined) {
            this.iconPosition = 'before';
        }
    };
    ODataTableOptionComponent.prototype.innerOnClick = function (event) {
        this.onClick.emit(event);
    };
    ODataTableOptionComponent.DEFAULT_INPUTS_O_DATATABLE_OPTION = DEFAULT_INPUTS_O_DATATABLE_OPTION;
    ODataTableOptionComponent.DEFAULT_OUTPUTS_O_DATATABLE_OPTION = DEFAULT_OUTPUTS_O_DATATABLE_OPTION;
    ODataTableOptionComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable-option',
                    template: '',
                    inputs: DEFAULT_INPUTS_O_DATATABLE_OPTION.slice(),
                    outputs: DEFAULT_OUTPUTS_O_DATATABLE_OPTION.slice()
                },] },
    ];
    ODataTableOptionComponent.ctorParameters = function () { return [
        { type: ODataTableComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ODataTableComponent; }),] },] },
    ]; };
    return ODataTableOptionComponent;
}());
export { ODataTableOptionComponent };
//# sourceMappingURL=o-datatable-option.component.js.map