import { OnInit, Injector, EventEmitter } from '@angular/core';
import { ODataTableComponent } from './o-datatable.component';
import { OTranslateService, MomentService, NumberService, CurrencyService } from 'ontimize-web-ng2';
export interface IDataTableCellRenderer {
    init(parameters: any): any;
    render(cellData: any, rowData: any): string;
    handleCreatedCell(cellElement: any, rowData: any): any;
}
export interface IDataTableCellEditor {
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    onSubmit: EventEmitter<any>;
    init(parameters: any): any;
    getHtml(data: any): string;
    handleCellFocus(cellElement: any, data: any): any;
    handleCellBlur(cellElement: any): any;
    create(cellElement: any, data: any): any;
    destroy(cellElement: any): any;
    performInsertion(cellElement: any): any;
    createEditorForInsertTable(cellElement: any, data: any): any;
    getInsertTableValue(): any;
}
export declare const DEFAULT_INPUTS_O_DATATABLE_COLUMN: string[];
export declare class ODataTableColumnComponent implements OnInit {
    protected injector: Injector;
    static DEFAULT_INPUTS_O_DATATABLE_COLUMN: string[];
    protected static DEFAULT_DATE_MODEL_TYPE: string;
    protected static DEFAULT_DATE_MODEL_FORMAT: string;
    protected table: ODataTableComponent;
    protected translateService: OTranslateService;
    protected momentService: MomentService;
    protected numberService: NumberService;
    protected currencyService: CurrencyService;
    protected renderer: IDataTableCellRenderer;
    protected editor: IDataTableCellEditor;
    attr: string;
    title: string;
    orderable: any;
    searchable: any;
    editable: any;
    type: string;
    protected format: string;
    protected dateModelType: string;
    protected dateModelFormat: string;
    protected trueValueType: string;
    protected trueValue: string;
    protected falseValueType: string;
    protected falseValue: string;
    protected grouping: any;
    protected thousandSeparator: string;
    protected decimalSeparator: string;
    protected decimalDigits: number;
    protected currencySymbol: string;
    protected currencySymbolPosition: string;
    protected imageType: string;
    protected avatar: string;
    protected emptyImage: string;
    protected action: string;
    protected renderType: string;
    protected renderValue: string;
    protected translate: any;
    generatedAttr: string;
    width: string;
    class: string;
    cellData: any;
    cellElement: any;
    constructor(table: ODataTableComponent, injector: Injector);
    ngOnInit(): void;
    setWidth(value: any): void;
    getColumnName(): string;
    registerRenderer(renderer: IDataTableCellRenderer): void;
    updateRendererType(rendererType: string): void;
    registerEditor(editor: IDataTableCellEditor): void;
    render(cellData: any, rowData: any): string;
    handleCreatedCell(cellElement: any, rowData: any): void;
    updateCell(cellElement: any, value: any, sqltypes?: any): void;
    updateRow(cellElement: any, av: any): void;
    viewDetail(item: any): void;
    editDetail(item: any): void;
    remove(item: any): void;
    renderRowRenderers(cellElement: any, rowData: any): void;
    renderRowEditors(cellElement: any): void;
    getRowEditorsAttrValues(cellElement: any): any;
    getRowData(): any;
}
