var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import * as $ from 'jquery';
import { Component, Inject, Injector, ElementRef, forwardRef, Optional, EventEmitter, NgModule, ViewEncapsulation, ViewChild } from '@angular/core';
import { RouterModule, NavigationStart, RoutesRecognized } from '@angular/router';
import { CommonModule } from '@angular/common';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/observable/from';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/mergeAll';
import { InputConverter, ObservableWrapper, dataServiceFactory, OntimizeService, MomentService, Util, OFormComponent, OFormValue, OSharedModule, OServiceComponent, ODateInputModule, OFormModule } from 'ontimize-web-ng2';
import { MdMenuTrigger, MdTabGroup, MdTab } from '@angular/material';
import { ODataTableCellEditorDateDialog } from './cell-editor/dialog/o-datatable-cell-editor-date-dialog.component';
import { ODataTableColumnComponent } from './o-datatable-column.component';
import { ODataTableCellEditorBooleanComponent, ODataTableCellEditorComboComponent, ODataTableCellEditorDateComponent, ODataTableCellEditorIntegerComponent, ODataTableCellEditorRealComponent, ODataTableCellEditorStringComponent } from './cell-editor/cell-editor';
import { ODataTableCellRendererActionComponent, ODataTableCellRendererBooleanComponent, ODataTableCellRendererCurrencyComponent, ODataTableCellRendererDateComponent, ODataTableCellRendererImageComponent, ODataTableCellRendererIntegerComponent, ODataTableCellRendererRealComponent, ODataTableCellRendererServiceComponent, ODataTableCellRendererStringComponent } from './cell-renderer/cell-renderer';
import { ODataTableButtonComponent, ODataTableOptionComponent, } from './header-components/header-components';
import './o-datatable.loader';
var TABLE_CHECKBOX_TEMPLATE = "\n  <div class=\"mat-checkbox-inner-container\">\n    <input class=\"mat-checkbox-input select-row\" type=\"checkbox\" name=\"id[]\">\n    <div class=\"mat-checkbox-ripple mat-ripple\" md-ripple=\"\"></div>\n    <div class=\"mat-checkbox-frame\"></div>\n    <div class=\"mat-checkbox-background\">\n      <svg space=\"preserve\" class=\"mat-checkbox-checkmark\" version=\"1.1\" viewBox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\">\n        <path class=\"mat-checkbox-checkmark-path\" d=\"M4.1,12.7 9,17.6 20.3,6.3\" fill=\"none\" stroke=\"white\"></path>\n      </svg>\n      <div class=\"mat-checkbox-mixedmark\"></div>\n    </div>\n  </div>\n";
export var DEFAULT_INPUTS_O_DATATABLE = OServiceComponent.DEFAULT_INPUTS_O_SERVICE_COMPONENT.concat([
    'insertMethod: insert-method',
    'updateMethod: update-method',
    'visibleColumns: visible-columns',
    'editableColumns: editable-columns',
    'editOnFocus: edit-on-focus',
    'sortColumns: sort-columns',
    'quickFilter: quick-filter',
    'deleteButton: delete-button',
    'refreshButton: refresh-button',
    'columnsVisibilityButton: columns-visibility-button',
    'columnsResizeButton: columns-resize-button',
    'columnsGroupButton: columns-group-button',
    'exportButton: export-button',
    'insertTable: insert-table',
    'editionMode: edition-mode',
    'showTableButtonsText: show-table-buttons-text',
    'selectAllCheckbox: select-all-checkbox',
    'singlePageMode : single-page-mode',
    'paginationControls : pagination-controls'
]);
export var DEFAULT_OUTPUTS_O_DATATABLE = [
    'onClick',
    'onRowSelected',
    'onRowDeselected',
    'onRowDeleted',
    'onDoubleClick',
    'onTableDataLoaded',
    'onPaginatedTableDataLoaded'
];
var ODataTableComponent = (function (_super) {
    __extends(ODataTableComponent, _super);
    function ODataTableComponent(injector, elRef, form) {
        var _this = _super.call(this, injector, elRef, form) || this;
        _this.editOnFocus = true;
        _this.quickFilter = true;
        _this.deleteButton = true;
        _this.refreshButton = true;
        _this.columnsVisibilityButton = true;
        _this.columnsResizeButton = true;
        _this.columnsGroupButton = true;
        _this.exportButton = true;
        _this.insertTable = false;
        _this.showTableButtonsText = true;
        _this.selectAllCheckbox = true;
        _this.singlePageMode = false;
        _this.paginationControls = true;
        _this.showOptionsButton = true;
        _this.showExportOptions = false;
        _this.pendingQuery = false;
        _this.pendingQueryFilter = undefined;
        _this.onRowSelected = new EventEmitter();
        _this.onRowDeselected = new EventEmitter();
        _this.onRowDeleted = new EventEmitter();
        _this.onClick = new EventEmitter();
        _this.onDoubleClick = new EventEmitter();
        _this.onTableDataLoaded = new EventEmitter();
        _this.onPaginatedTableDataLoaded = new EventEmitter();
        _this.storedRecordsIndexes = [];
        _this.initialColumnsWidths = [];
        _this.isProgrammaticSelection = false;
        _this.isProgrammaticChange = false;
        try {
            _this.mdTabGroupContainer = _this.injector.get(MdTabGroup);
            _this.mdTabContainer = _this.injector.get(MdTab);
        }
        catch (error) {
        }
        _this.initialized = false;
        _this.momentService = _this.injector.get(MomentService);
        _this.lastDeselection = undefined;
        _this.groupColumnIndex = -1;
        _this.groupColumnOrder = ODataTableComponent.TYPE_ASC_NAME;
        var showAllIndex = ODataTableComponent.DEFAULT_QUERY_ROWS_MENU[0].indexOf(-1);
        if (showAllIndex !== -1) {
            ODataTableComponent.DEFAULT_QUERY_ROWS_MENU[1][showAllIndex] = _this.translateService.get('TABLE.SHOW_ALL');
        }
        _this.headerButtons = [];
        _this.headerOptions = [];
        _this.onRouterNavigateSubscribe = _this.router.events.subscribe(function (route) {
            if ((typeof (_this.oattr) === 'undefined') ||
                !(route instanceof NavigationStart || route instanceof RoutesRecognized) ||
                ((route instanceof NavigationStart || route instanceof RoutesRecognized) && (!route.url.startsWith(_this.router.url)))) {
                var localStorageState = localStorage.getItem('DataTables' + '_' + _this.oattr + '_' + _this.router.url);
                if (localStorageState) {
                    var state = JSON.parse(localStorageState);
                    delete state.start;
                    delete state.selectedIndex;
                    localStorage.setItem('DataTables' + '_' + _this.oattr + '_' + _this.router.url, JSON.stringify(state));
                }
            }
        });
        _this.onInsertRowFocusSubscribe = [];
        _this.onInsertRowSubmitSubscribe = undefined;
        return _this;
    }
    ODataTableComponent.prototype.onLanguageChangeCallback = function (res) {
        if (this.mdTabContainer === undefined || this.mdTabContainer.content.isAttached) {
            this.reinitializeTable();
        }
    };
    ODataTableComponent.prototype.getComponentKey = function () {
        return 'DataTables_' + this.oattr;
    };
    ODataTableComponent.prototype.setTableInitialState = function () {
        this.dataArray = [];
        this.storedRecordsIndexes = [];
    };
    ODataTableComponent.prototype.reinitializeTable = function () {
        this.isProgrammaticChange = true;
        if (this.dataTable) {
            this.dataTable.fnDestroy();
            $(this.tableHtmlEl).children().remove();
        }
        this.dataTable = null;
        this.state.queryRecordOffset = 0;
        if (this.dataTableOptions) {
            this.setTableInitialState();
            this.initTableOnInit(this.dataTableOptions.columns);
            this.initTableAfterViewInit();
            if ((typeof (this.table) !== 'undefined') && (this.sortColumnsArray.length > 0)) {
                this.table.order(this.sortColumnsArray);
                this.table.draw();
            }
        }
        this.isProgrammaticChange = false;
    };
    ODataTableComponent.prototype.ngOnInit = function () {
        this.initialize();
        this.extendDataTablesSortMethods();
    };
    ODataTableComponent.prototype.getNumberComparisionValues = function (x, y, valueAttr) {
        var result = [];
        if ((x.indexOf(valueAttr) !== -1) && (y.indexOf(valueAttr) !== -1)) {
            var tmpx = x.substr(x.indexOf(valueAttr) + valueAttr.length + 2);
            tmpx = tmpx.substr(0, tmpx.indexOf('"'));
            result.push(parseFloat(tmpx));
            var tmpy = y.substr(y.indexOf(valueAttr) + valueAttr.length + 2);
            tmpy = tmpy.substr(0, tmpy.indexOf('"'));
            result.push(parseFloat(tmpy));
        }
        return result;
    };
    ODataTableComponent.prototype.compareNumeric = function (x, y, valueAttr, asc) {
        var _a = this.getNumberComparisionValues(x, y, valueAttr), xV = _a[0], yV = _a[1];
        var diff = 0;
        if (xV !== undefined && yV !== undefined) {
            diff = xV - yV;
        }
        else {
            diff = x - y;
        }
        if (diff === 0) {
            return 0;
        }
        if (asc) {
            return (diff < 0) ? -1 : 1;
        }
        else {
            return (diff < 0) ? 1 : -1;
        }
    };
    ODataTableComponent.prototype.extendDataTablesSortMethods = function () {
        var self = this;
        var sortMethods = ($.fn.dataTableExt.oSort);
        if (!sortMethods.hasOwnProperty('o-number-asc')) {
            sortMethods['o-number-asc'] = function (x, y) {
                return self.compareNumeric(x, y, 'o-number-value', true);
            };
        }
        if (!sortMethods.hasOwnProperty('o-number-desc')) {
            sortMethods['o-number-desc'] = function (x, y) {
                return self.compareNumeric(x, y, 'o-number-value', false);
            };
        }
        if (!sortMethods.hasOwnProperty('o-timestamp-asc')) {
            sortMethods['o-timestamp-asc'] = function (x, y) {
                return self.compareNumeric(x, y, 'o-timestamp-value', true);
            };
        }
        if (!sortMethods.hasOwnProperty('o-timestamp-desc')) {
            sortMethods['o-timestamp-desc'] = function (x, y) {
                return self.compareNumeric(x, y, 'o-timestamp-value', false);
            };
        }
    };
    ODataTableComponent.prototype.reinitialize = function (options) {
        _super.prototype.reinitialize.call(this, options);
        this.editColumnIndex = undefined;
        this.detailColumnIndex = undefined;
        if (options && Object.keys(options).length) {
            if (this.table) {
                this.table.destroy();
                this.dataTable.children().remove();
            }
            this.reinitializeTable();
        }
    };
    ODataTableComponent.prototype.initialize = function () {
        if (!this.detailButtonInRowIcon) {
            this.detailButtonInRowIcon = ODataTableComponent.DEFAULT_DETAIL_ICON;
        }
        _super.prototype.initialize.call(this);
        this.dataParentKeys = [];
        if (this.parentKeys) {
            var keys = Util.parseArray(this.parentKeys);
            for (var i = 0; i < keys.length; ++i) {
                var key = keys[i];
                var keyDef = key.split(ODataTableComponent.COLUMNS_ALIAS_SEPARATOR);
                if (keyDef.length === 1) {
                    this.dataParentKeys.push({
                        'alias': keyDef[0],
                        'name': keyDef[0]
                    });
                }
                else if (keyDef.length === 2) {
                    this.dataParentKeys.push({
                        'alias': keyDef[0],
                        'name': keyDef[1]
                    });
                }
            }
        }
        this.queryRowsMenu = [];
        this.queryRowsMenu[0] = ODataTableComponent.DEFAULT_QUERY_ROWS_MENU[0].slice();
        this.queryRowsMenu[1] = ODataTableComponent.DEFAULT_QUERY_ROWS_MENU[1].slice();
        if (this.queryRowsMenu[0].indexOf(this.queryRows) === -1) {
            for (var i = 0; i < this.queryRowsMenu[0].length; i++) {
                var item = this.queryRowsMenu[0][i];
                if (item > this.queryRows || item === -1) {
                    this.queryRowsMenu[0].splice(i, 0, this.queryRows);
                    this.queryRowsMenu[1].splice(i, 0, this.queryRows);
                    break;
                }
            }
        }
        var localStorageState = localStorage.getItem('DataTables' + '_' + this.oattr + '_' + this.router.url);
        if (localStorageState) {
            this.state = JSON.parse(localStorageState);
        }
        else {
            this.state = {};
        }
        this.visibleColumnsArray = Util.parseArray(this.visibleColumns);
        this.editableColumnsArray = Util.parseArray(this.editableColumns);
        if (!this.insertMethod) {
            this.insertMethod = 'insert';
        }
        if (!this.updateMethod) {
            this.updateMethod = 'update';
        }
        if (this.insertButton === undefined) {
            this.insertButton = true;
        }
        if (this.mdTabGroupContainer && this.mdTabContainer) {
            var self = this;
            this.mdTabGroupContainer.selectChange.subscribe(function (evt) {
                var interval = setInterval(function () { timerCallback(evt.tab); }, 100);
                function timerCallback(tab) {
                    if (tab && tab.content.isAttached) {
                        clearInterval(interval);
                        if (tab === self.mdTabContainer) {
                            if (self.table === undefined) {
                                self.reinitializeTable();
                            }
                            if (self.pendingQuery) {
                                self.queryData(self.pendingQueryFilter);
                            }
                        }
                    }
                }
            });
        }
        this.initTableOnInit();
    };
    ODataTableComponent.prototype.ngOnDestroy = function () {
        this.destroy();
    };
    ODataTableComponent.prototype.destroy = function () {
        _super.prototype.destroy.call(this);
        this.onRouterNavigateSubscribe.unsubscribe();
        for (var i = 0; i < this.onInsertRowFocusSubscribe.length; ++i) {
            this.onInsertRowFocusSubscribe[i].unsubscribe();
        }
        if (typeof (this.onInsertRowSubmitSubscribe) !== 'undefined') {
            this.onInsertRowSubmitSubscribe.unsubscribe();
        }
    };
    ODataTableComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.mdTabContainer === undefined
            || this.mdTabContainer.content.isAttached) {
            this.initTableAfterViewInit();
        }
        if (this.menuTrigger) {
            this.menuTrigger.onMenuOpen.subscribe(function (args) { return _this.onOptionsMenuShow(args); });
        }
    };
    ODataTableComponent.prototype.ngOnChanges = function (changes) {
        if ((typeof (changes['staticData']) !== 'undefined') && (typeof (this.dataTable) !== 'undefined')) {
            this.dataTable.fnClearTable(false);
            this.dataArray = changes['staticData'].currentValue;
            if (this.dataArray.length > 0) {
                this.dataTable.fnAddData(this.dataArray);
            }
            this.dataTable.fnDraw();
        }
    };
    ODataTableComponent.prototype.refresh = function () {
        this.reloadData();
    };
    ODataTableComponent.prototype.reloadData = function () {
        var newOffset = Math.max(this.state.queryRecordOffset - this.queryRows, 0);
        var queryArgs = {
            offset: newOffset,
            length: this.queryRows,
            resultRecordsIndex: newOffset,
            replace: true
        };
        var endIndex = queryArgs.offset + queryArgs.length;
        for (var i = this.storedRecordsIndexes.length - 1; i >= 0; i--) {
            var storedStart = this.storedRecordsIndexes[i].start;
            var storedEnd = this.storedRecordsIndexes[i].end;
            if ((storedStart === queryArgs.offset) && (storedEnd === endIndex)) {
                this.storedRecordsIndexes.splice(i, 1);
                break;
            }
        }
        this.queryData(this.parentItem, queryArgs);
    };
    ODataTableComponent.prototype.initTableOnInit = function (columns) {
        var _this = this;
        if (columns === void 0) { columns = undefined; }
        var self = this;
        var domOption = 'r<"dataTables_fill_remaining"<"o-table-scroll"t>>';
        if (this.paginationControls) {
            domOption += '<"dataTables_pagination_wrapper"pil>';
        }
        if (this.controls) {
            domOption = '<"dataTables_top_wrapper"B<"dataTables_filter_wrapper"<"dataTables_hidden_options">f><"dataTables_options">>' + domOption;
        }
        this.dataTableOptions = {
            data: this.dataArray,
            dom: domOption,
            buttons: this.getTableButtons(),
            select: !this.selectAllCheckbox,
            autoWidth: false,
            stateSave: true,
            filter: this.quickFilter,
            ordering: true,
            info: true,
            paging: true,
            pageLength: this.queryRows,
            lengthMenu: this.queryRowsMenu,
            pagingType: 'full',
            colResize: {
                tableWidthFixed: false
            },
            language: this.getLanguageLabels(),
            keys: true,
            columns: [],
            createdRow: function (row, data, dataIndex) {
                var tr = $(row);
                tr.children().each(function (i, e) {
                    var td = $(e);
                    var hasChildren = (td.children().length > 0);
                    if (hasChildren) {
                        var children = td.children();
                        if (typeof (children.attr('o-timestamp-value')) !== 'undefined') {
                            td.attr('o-timestamp-value', children.attr('o-timestamp-value'));
                            td.html(td.children().text());
                        }
                        if (typeof (children.attr('o-number-value')) !== 'undefined') {
                            td.attr('o-number-value', children.attr('o-number-value'));
                            td.html(td.children().text());
                        }
                    }
                });
            },
            initComplete: function (settings) {
                _this.handleColumnWidth(settings);
                var controlButtons = $('#' + _this.oattr + '_wrapper .generic-action');
                $.each(controlButtons, function (i, el) {
                    $(this).attr('title', $(this).find('span').text());
                });
                var customButtons = $('#' + _this.oattr + '_wrapper .custom-generic-action');
                $.each(customButtons, function (i, el) {
                    var btnEl = $(this);
                    var iconMatch = btnEl.attr('class').match(/icon-(.*)/);
                    var icon = '';
                    if (iconMatch !== null) {
                        icon = iconMatch[1];
                    }
                    btnEl.attr('data-icon', icon);
                    btnEl.attr('title', $(this).find('span').text());
                });
                var filterButton = $('#' + _this.oattr + '_wrapper .generic-action-filter');
                var filterInput = $('#' + _this.oattr + '_filter').find('input');
                if ((filterInput.length > 0) && (filterInput.val().length > 0)) {
                    filterButton.addClass('filtering');
                }
                else {
                    filterButton.removeClass('filtering');
                }
                filterInput.keyup(function () {
                    if (filterInput.val().length > 0) {
                        filterButton.addClass('filtering');
                    }
                    else {
                        filterButton.removeClass('filtering');
                    }
                });
            },
            drawCallback: function (settings) {
                if (_this.groupColumnIndex >= 0) {
                    var api = _this.dataTable.api();
                    var rows_1 = api.rows({ page: 'current' }).nodes();
                    var last_1 = null;
                    api.column(_this.groupColumnIndex, { page: 'current' }).data().each(function (group, i) {
                        if (last_1 !== group) {
                            $(rows_1).eq(i).before('<tr class="group"><td colspan="100%">' +
                                _this.dataTableOptions.columns[_this.groupColumnIndex].component.render(group) +
                                '</td></tr>');
                            last_1 = group;
                        }
                    });
                }
                if (_this.insertTable && _this.oenabled) {
                    for (var i = 0; i < _this.onInsertRowFocusSubscribe.length; ++i) {
                        _this.onInsertRowFocusSubscribe[i].unsubscribe();
                    }
                    _this.onInsertRowFocusSubscribe = [];
                    if (typeof (_this.onInsertRowSubmitSubscribe) !== 'undefined') {
                        _this.onInsertRowSubmitSubscribe.unsubscribe();
                        _this.onInsertRowSubmitSubscribe = undefined;
                    }
                    var tbody = $('#' + _this.oattr + '_wrapper table tbody');
                    tbody.append('<tr class="insertRow"></tr>');
                    var insertRow = tbody.find('.insertRow');
                    var lastEditor = true;
                    for (var i = settings.aoColumns.length - 1; i >= 0; --i) {
                        var colDef = settings.aoColumns[i];
                        if (colDef.bVisible) {
                            var tdClass = (i === 0 && _this.selectAllCheckbox) ? 'o-table-column-select-checkbox' : 'o-table-column-insert-table';
                            insertRow.prepend('<td class=' + tdClass + '></td>');
                            if (colDef.editable && (typeof (colDef.component) !== 'undefined') &&
                                (typeof (colDef.component.editor) !== 'undefined')) {
                                var insertCell = insertRow.find('td:first');
                                colDef.component.editor.createEditorForInsertTable(insertCell, undefined);
                                _this.onInsertRowFocusSubscribe.push(colDef.component.editor.onFocus.subscribe(function (res) {
                                    if (res.insertTable) {
                                        _this.table.rows().deselect();
                                        _this.table.cell.blur();
                                    }
                                }));
                                if (lastEditor && _this.dataService && (_this.insertMethod in _this.dataService) && _this.entity) {
                                    _this.onInsertRowSubmitSubscribe = colDef.component.editor.onSubmit.subscribe(function (res) {
                                        if (res.insertTable) {
                                            var av = _this.getAvToInsertFromTableSettings(settings, true);
                                            console.log('[ODataTable.initTableOnInit]: insert', av);
                                            _this.loaderSuscription = _this.load();
                                            _this.dataService[_this.insertMethod](av, _this.entity)
                                                .subscribe(function (res) {
                                                if ((typeof (res.code) === 'undefined') ||
                                                    ((typeof (res.code) !== 'undefined') && (res.code === 0))) {
                                                    _this.queryData(_this.parentItem);
                                                    console.log('[ODataTable.initTableOnInit]: insert ok', res);
                                                }
                                                else {
                                                    console.log('[ODataTable.initTableOnInit]: error', res.code);
                                                    _this.dialogService.alert('ERROR', 'MESSAGES.ERROR_INSERT');
                                                }
                                                _this.loaderSuscription.unsubscribe();
                                            }, function (err) {
                                                console.log('[ODataTable.initTableOnInit]: error', err);
                                                _this.loaderSuscription.unsubscribe();
                                                _this.dialogService.alert('ERROR', 'MESSAGES.ERROR_INSERT');
                                            });
                                        }
                                    });
                                    lastEditor = false;
                                }
                                else if (lastEditor && _this.staticData) {
                                    _this.onInsertRowSubmitSubscribe = colDef.component.editor.onSubmit.subscribe(function (res) {
                                        if (res.insertTable) {
                                            var av = _this.getAvToInsertFromTableSettings(settings, false);
                                            _this.staticData.push(av);
                                            _this.setDataArray(_this.staticData);
                                            if (typeof (_this.dataTable) !== 'undefined') {
                                                _this.dataTable.fnClearTable(false);
                                                if (_this.dataArray.length > 0) {
                                                    _this.dataTable.fnAddData(_this.dataArray);
                                                }
                                                _this.dataTable.fnDraw();
                                            }
                                        }
                                    });
                                    lastEditor = false;
                                }
                            }
                        }
                    }
                }
                var emptyRow = $('.dataTables_empty');
                if (emptyRow.length > 0) {
                    emptyRow.parent().addClass('empty');
                }
                if (self.pageable && self.dataArray && self.dataArray.length) {
                    self.updatePageableTable(!settings._drawHold);
                }
            },
            headerCallback: function (thead, data, start, end, display) {
                if (self.selectAllCheckbox) {
                    var checkboxCell = $(thead).find('th').eq(0);
                    checkboxCell.attr('class', 'o-table-column-select-checkbox');
                    checkboxCell.html(TABLE_CHECKBOX_TEMPLATE);
                    checkboxCell.find('.select-row').attr('id', 'select_all');
                }
            }
        };
        if (typeof (columns) !== 'undefined') {
            for (var i = 0; i < columns.length; ++i) {
                var col = columns[i];
                if ((typeof (col.title) === 'string') && (col.name === col.data)) {
                    col.title = this.translateService.get(col.name);
                    col.sTitle = col.title;
                }
            }
            this.dataTableOptions.columns = columns;
        }
        else {
            if (this.selectAllCheckbox) {
                this.dataTableOptions.columns.push({
                    selectAllColumn: true,
                    searchable: false,
                    orderable: false,
                    className: 'o-table-column-select-checkbox',
                    render: function (data, type, full, meta) {
                        return TABLE_CHECKBOX_TEMPLATE;
                    }
                });
            }
            for (var i = 0; i < this.visibleColumnsArray.length; ++i) {
                var col = this.visibleColumnsArray[i];
                var colDef = {
                    data: col,
                    name: col,
                    title: this.translateService.get(col),
                    className: 'o-table-column',
                    defaultContent: '',
                    orderable: true,
                    searchable: true,
                    editable: (this.editableColumnsArray.indexOf(col) !== -1),
                    visible: (this.visibleColumnsArray.indexOf(col) !== -1)
                };
                if (this.editOnFocus && colDef.editable) {
                    colDef.className += ' editable';
                }
                this.dataTableOptions.columns.push(colDef);
            }
        }
        this.sortColumnsArray = [];
        if (this.sortColumns) {
            var cols = Util.parseArray(this.sortColumns);
            for (var i = 0; i < cols.length; ++i) {
                var col = cols[i];
                var colDef = col.split(ODataTableComponent.TYPE_SEPARATOR);
                if (colDef.length > 0) {
                    var colName = colDef[0];
                    for (var colIndex = 0; colIndex < this.dataTableOptions.columns.length; ++colIndex) {
                        if (colName === this.dataTableOptions.columns[colIndex].name) {
                            var sortDirection = ODataTableComponent.TYPE_ASC_NAME;
                            if (colDef.length > 1) {
                                sortDirection = colDef[1].toLowerCase();
                                switch (sortDirection) {
                                    case ODataTableComponent.TYPE_DESC_NAME:
                                        sortDirection = ODataTableComponent.TYPE_DESC_NAME;
                                        break;
                                }
                            }
                            this.sortColumnsArray.push([colIndex, sortDirection]);
                        }
                    }
                }
            }
            if ((typeof (columns) !== 'undefined') && (this.sortColumnsArray.length > 0)) {
                this.dataTableOptions.order = this.sortColumnsArray;
            }
        }
    };
    ODataTableComponent.prototype.getColumsNumber = function () {
        return this.dataTableOptions.columns.length;
    };
    ODataTableComponent.prototype.addDefaultRowButtons = function () {
        this.editColumnIndex = -1;
        this.detailColumnIndex = -1;
        if (this.editButtonInRow) {
            var editColumn = new ODataTableColumnComponent(this, this.injector);
            var editColumnRenderer = new ODataTableCellRendererActionComponent(editColumn, this.injector);
            editColumnRenderer.init({
                action: 'edit',
                editionMode: this.editionMode,
                renderType: 'icon',
                renderValue: this.editButtonInRowIcon
            });
            this.editColumnIndex = this.dataTableOptions.columns.length;
            this.registerColumn(editColumn);
        }
        if (this.detailButtonInRow) {
            var detailColumn = new ODataTableColumnComponent(this, this.injector);
            var detailColumnRenderer = new ODataTableCellRendererActionComponent(detailColumn, this.injector);
            detailColumnRenderer.init({
                action: 'detail',
                renderType: 'icon',
                renderValue: this.detailButtonInRowIcon
            });
            this.detailColumnIndex = this.dataTableOptions.columns.length;
            this.registerColumn(detailColumn);
        }
    };
    ODataTableComponent.prototype.onOptionsMenuShow = function (args) {
        var menuEl = $('.mat-overlay-container .mat-menu');
        var menuContainer = menuEl.parent();
        if (menuContainer) {
            var menuBtn = $(this.elRef.nativeElement).find('.o-table-menu-button');
            var menuBtnOffset = menuBtn.offset();
            var top = menuBtnOffset.top + menuBtn.outerHeight(true) - 30;
            var left = menuBtnOffset.left - menuEl.outerWidth(true) + menuBtn.outerWidth(true) - 16;
            menuContainer.css('transform', 'translateX(' + left + 'px) translateY(' + top + 'px)');
        }
    };
    ODataTableComponent.prototype.parseTableOptions = function () {
        var tableOptions = [];
        if (this.controls) {
            tableOptions = this.getTableOptions();
            if (tableOptions.length > 0) {
                var table = this.table;
                var btns = new $.fn.dataTable.Buttons(table, {
                    buttons: tableOptions
                });
                table.buttons(1, null).container().appendTo($(table.table().container()).find('.dataTables_top_wrapper .dataTables_hidden_options'));
            }
        }
        this.showOptionsButton = (tableOptions.length > 0 || this.headerOptions.length > 0);
    };
    ODataTableComponent.prototype.initTableAfterViewInit = function () {
        var _this = this;
        this.tableHtmlEl = $('#' + this.oattr);
        if ((this.tableHtmlEl.length > 0) && (this.tableHtmlEl[0].tagName !== 'TABLE')) {
            this.tableHtmlEl = this.tableHtmlEl.find('table');
        }
        if ((typeof (this.editColumnIndex) === 'undefined') && (typeof (this.detailColumnIndex) === 'undefined')) {
            this.addDefaultRowButtons();
        }
        this.table = this.tableHtmlEl.DataTable(this.dataTableOptions);
        var fxdHeader = new $.fn.dataTable.FixedHeader(this.table, {
            header: true,
            forceFloating: true,
            scrollWidth: 20
        });
        this.parseTableOptions();
        if (typeof (this.state.length) === 'number') {
            this.queryRows = this.state.length;
            if (this.queryRows === -1) {
                this.queryRows = this.state.queryTotalRecordNumber ? this.state.queryTotalRecordNumber : OServiceComponent.DEFAULT_QUERY_ROWS;
            }
        }
        this.isProgrammaticChange = true;
        this.table.page.len(this.queryRows).draw(false);
        this.isProgrammaticChange = false;
        var startRecordValue = 0;
        if (typeof (this.state.start) === 'number') {
            startRecordValue = this.state.start;
        }
        this.state.queryRecordOffset = startRecordValue;
        if (!this.selectAllCheckbox) {
            this.table.off('select').on('select', function (event, dt, type, indexes) {
                if (_this.oenabled) {
                    if (typeof (indexes) !== 'undefined') {
                        event.preventDefault();
                        event.stopPropagation();
                        _this.handleSelection(event, dt, type, indexes);
                    }
                }
            });
            this.table.off('deselect').on('deselect', function (event, dt, type, indexes) {
                if (_this.oenabled) {
                    if (typeof (indexes) !== 'undefined') {
                        event.preventDefault();
                        event.stopPropagation();
                        _this.handleDeselection(event, dt, type, indexes);
                    }
                }
            });
        }
        this.table.off('key').on('key', function (event, dt, key, cell, originalEvent) {
            if (_this.oenabled) {
                var colIndex = cell.index()['column'];
                var colDef = _this.table.settings().init().columns[colIndex];
                var colType = colDef.type;
                if (typeof (colDef.component) !== 'undefined') {
                    colType = colDef.component.type;
                }
            }
        });
        this.table.off('key-focus').on('key-focus', function (event, dt, cell) {
            if (_this.oenabled) {
                if (!_this.selectAllCheckbox) {
                    var indexes = [cell.index()['row']];
                    _this.table.rows(indexes).select();
                }
                var cellEl = $(cell.nodes());
                var colIndex = cell.index()['column'];
                var colDef = _this.table.settings().init().columns[colIndex];
                if (_this.editOnFocus && colDef.editable && (typeof (colDef.component) !== 'undefined') &&
                    (typeof (colDef.component.editor) !== 'undefined')) {
                    if (cellEl.hasClass('editable')) {
                        colDef.component.editor.handleCellFocus(cellEl, cell.data());
                    }
                    else {
                        cellEl.removeClass('focus');
                    }
                }
                else if (!_this.editOnFocus) {
                    cellEl.removeClass('focus');
                }
            }
        });
        this.table.off('key-blur').on('key-blur', function (event, dt, cell) {
            if (_this.oenabled) {
                var colIndex = cell.index()['column'];
                var colDef = _this.table.settings().init().columns[colIndex];
                if (_this.editOnFocus && colDef.editable && (typeof (colDef.component) !== 'undefined') &&
                    (typeof (colDef.component.editor) !== 'undefined')) {
                    var cellEl = $(cell.nodes());
                    if (cellEl.hasClass('editable')) {
                        colDef.component.editor.handleCellBlur(cellEl);
                    }
                    else {
                        cellEl.removeClass('focus');
                    }
                }
            }
        });
        var self = this;
        this.table.off('draw.dt').on('draw.dt', function () {
            self.tableHtmlEl.find('tr').off('click').on('click', function (event) { return _this.handleClick(event); });
            self.tableHtmlEl.find('tr').off('dblclick').on('dblclick', function (event) { return _this.handleDoubleClick(event); });
            if (_this.selectAllCheckbox) {
                self.tableHtmlEl.find('th #select_all').off('click').on('click', function (event) { return _this.handleSelectAllClick(event); });
                self.tableHtmlEl.find('tbody tr .select-row').off('change').on('change', function (event) { return _this.handleRowCheckboxChange(event); });
            }
        });
        this.table.on('order.dt', function () {
            if (self.isProgrammaticChange) {
                return;
            }
            var order = _this.table.order();
            if ((_this.groupColumnIndex !== -1) && (order[0][0] !== _this.groupColumnIndex)) {
                order.unshift([_this.groupColumnIndex, _this.groupColumnOrder]);
                _this.table.order(order);
                _this.dataTable.fnDraw();
            }
            _this.handleOrderIndex();
            var emptyRow = $('.dataTables_empty');
            if (emptyRow.length > 0) {
                emptyRow.parent().addClass('empty');
            }
        });
        this.table.off('column-visibility.dt').on('column-visibility.dt', function (e, settings, column, state) {
            if (self.isProgrammaticChange) {
                return;
            }
            _this.handleColumnWidth(settings);
            _this.handleOrderIndex();
            var resizeButton = $('#' + _this.oattr + '_wrapper .generic-action-resize');
            if (resizeButton.hasClass('active')) {
                _this.initColumnResize();
            }
            _this.initColumnGroup();
        });
        this.table.off('length.dt').on('length.dt', function (e, settings, len) {
            if (self.isProgrammaticChange) {
                return;
            }
            setTimeout(function () {
                var resizeButton = $('#' + self.oattr + '_wrapper .generic-action-resize');
                if (resizeButton.hasClass('active')) {
                    self.initColumnResize();
                }
                if (self.pageable && self.dataArray && self.dataArray.length > 0) {
                    var newFirstPageRecord = Math.floor((self.state.queryRecordOffset - self.queryRows) / len) * len;
                    self.setTableInitialState();
                    self.queryRows = (len !== -1) ? len : (self.state.queryTotalRecordNumber || -1);
                    var queryArgs = {
                        offset: newFirstPageRecord,
                        length: self.queryRows
                    };
                    self.queryData(_this.parentItem, queryArgs);
                }
            }, 100);
        });
        this.table.off('search.dt').on('search.dt', function () {
            if (self.isProgrammaticChange) {
                return;
            }
            setTimeout(function () {
                var resizeButton = $('#' + _this.oattr + '_wrapper .generic-action-resize');
                if (resizeButton.hasClass('active')) {
                    _this.initColumnResize();
                }
            }, 100);
        });
        this.initColumnGroup();
        this.dataTable = this.tableHtmlEl.dataTable();
        this.initialized = true;
        if (this.staticData) {
            this.setDataArray(this.staticData);
        }
        else if (this.queryOnInit) {
            this.queryData(this.parentItem);
        }
    };
    ODataTableComponent.prototype.setInitialColumnWidth = function (column) {
        this.initialColumnsWidths.push({
            name: column.getColumnName(),
            width: column.width
        });
    };
    ODataTableComponent.prototype.registerColumn = function (column, index) {
        var colDef = {
            data: undefined,
            name: undefined,
            component: column,
            title: this.translateService.get(column.title),
            type: 'string',
            className: 'o-table-column ' + (column.class || '') + ' ',
            defaultContent: '',
            orderable: true,
            searchable: true,
            editable: false,
            visible: true,
            render: function (data, type, item, meta) { return column.render(data, item); },
            createdCell: function (cellElement, cellData, item, rowIndex, colIndex) {
                return column.handleCreatedCell($(cellElement), item);
            }
        };
        if (column.width) {
            this.setInitialColumnWidth(column);
        }
        if (typeof (column.attr) === 'undefined') {
            colDef.className += ' o-table-column-action';
            colDef.orderable = false;
            colDef.searchable = false;
            colDef.name = column.generatedAttr;
        }
        else {
            colDef.data = column.attr;
            colDef.name = column.attr;
            this.setColumnDefTypeAttributes(colDef, column.type);
            colDef.orderable = column.orderable;
            colDef.searchable = column.searchable;
            colDef.editable = column.editable;
            if (this.editOnFocus && colDef.editable) {
                colDef.className += ' editable';
            }
            colDef.visible = (this.visibleColumnsArray.indexOf(column.attr) !== -1);
        }
        if (typeof (column.attr) !== 'undefined') {
            if (this.colArray.indexOf(column.attr) === -1) {
                this.colArray.push(column.attr);
            }
            var alreadyExisting = this.dataTableOptions.columns.filter(function (existingColumn) {
                return existingColumn.name === column.attr;
            });
            if (alreadyExisting.length === 1) {
                var replacingIndex = this.dataTableOptions.columns.indexOf(alreadyExisting[0]);
                this.dataTableOptions.columns[replacingIndex] = colDef;
            }
            else if (alreadyExisting.length === 0) {
                this.dataTableOptions.columns.push(colDef);
            }
        }
        else {
            this.dataTableOptions.columns.push(colDef);
        }
    };
    ODataTableComponent.prototype.setColumnDefTypeAttributes = function (colDef, type) {
        switch (type) {
            case 'boolean':
                colDef.className += 'o-table-column-boolean';
                colDef.type = 'string';
                break;
            case 'string':
                colDef.className += 'o-table-column-string';
                colDef.type = 'string';
                break;
            case 'integer':
            case 'real':
            case 'currency':
                colDef.className += 'o-table-column-number';
                colDef.type = 'o-number';
                break;
            case 'date':
                colDef.className += 'o-table-column-date';
                colDef.type = 'o-timestamp';
                break;
            case 'image':
                colDef.className += 'o-table-column-image';
                colDef.type = 'string';
                break;
            default:
                colDef.className += 'o-table-column-string';
                colDef.type = 'string';
                break;
        }
    };
    ODataTableComponent.prototype.updateDataTableOptions = function (columnAttr, type) {
        if (type !== undefined && this.dataTableOptions !== undefined && this.dataTableOptions.columns !== undefined) {
            var columns = this.dataTableOptions.columns;
            for (var i = 0, len = columns.length; i < len; i++) {
                if (columns[i].data === columnAttr) {
                    this.setColumnDefTypeAttributes(columns[i], type);
                    break;
                }
            }
        }
    };
    ODataTableComponent.prototype.updateCell = function (cellElement, value, sqltypes) {
        var _this = this;
        var cell = this.table.cell(cellElement);
        if ((value !== cell.data()) && this.dataService && (this.updateMethod in this.dataService) && this.entity &&
            (this.keysArray.length > 0)) {
            var oldValue = cell.data();
            var colIndex = cell.index()['column'];
            var colDef = this.table.settings().init().columns[colIndex];
            var indexes = [cell.index()['row']];
            var rowDataArray = this.table.rows(indexes).data().toArray();
            if (rowDataArray.length === 1) {
                var rowData_1 = rowDataArray[0];
                console.log('[ODataTable.updateCell]: before update', rowData_1);
                var kv = {};
                for (var k = 0; k < this.keysArray.length; ++k) {
                    var key = this.keysArray[k];
                    kv[key] = rowData_1[key];
                }
                var av = {};
                av[colDef.name] = value;
                this.loaderSuscription = this.load();
                this.dataService[this.updateMethod](kv, av, this.entity, sqltypes).subscribe(function (res) {
                    if ((typeof (res.code) === 'undefined') ||
                        ((typeof (res.code) !== 'undefined') && (res.code === 0))) {
                        cell.data(value);
                        if (typeof (cellElement.attr('o-timestamp-value')) !== 'undefined') {
                            cellElement.attr('o-timestamp-value', value);
                        }
                        if (typeof (cellElement.attr('o-number-value')) !== 'undefined') {
                            cellElement.attr('o-number-value', value);
                        }
                        console.log('[ODataTable.updateCell]: after update', rowData_1);
                    }
                    else {
                        console.log('[ODataTable.updateCell]: error', res.code);
                        _this.dialogService.alert('ERROR', 'MESSAGES.ERROR_UPDATE');
                        cell.data(oldValue);
                    }
                    _this.loaderSuscription.unsubscribe();
                }, function (err) {
                    console.log('[ODataTable.updateCell]: error', err);
                    _this.dialogService.alert('ERROR', 'MESSAGES.ERROR_UPDATE');
                    cell.data(oldValue);
                    _this.loaderSuscription.unsubscribe();
                });
            }
        }
        else {
            cell.data(value);
        }
    };
    ODataTableComponent.prototype.updateRow = function (cellElement, av) {
        var _this = this;
        if (typeof (av) !== 'undefined') {
            var rowCurrentData = this.table.row(cellElement).data();
            console.log('[ODataTable.updateRow]: before update', rowCurrentData);
            var kv = {};
            for (var k = 0; k < this.keysArray.length; ++k) {
                var key = this.keysArray[k];
                kv[key] = rowCurrentData[key];
            }
            this.loaderSuscription = this.load();
            this.dataService[this.updateMethod](kv, av, this.entity)
                .subscribe(function (res) {
                if ((typeof (res.code) === 'undefined') ||
                    ((typeof (res.code) !== 'undefined') && (res.code === 0))) {
                    console.log('[ODataTable.updateRow]: after update', _this.table.row(cellElement).data());
                }
                else {
                    console.log('[ODataTable.updateRow]: error', res.code);
                    _this.dialogService.alert('ERROR', 'MESSAGES.ERROR_UPDATE');
                }
                _this.loaderSuscription.unsubscribe();
            }, function (err) {
                console.log('[ODataTable.updateRow]: error', err);
                _this.dialogService.alert('ERROR', 'MESSAGES.ERROR_UPDATE');
                _this.loaderSuscription.unsubscribe();
            });
        }
    };
    ODataTableComponent.prototype.handleColumnWidth = function (settings) {
        var self = this;
        var tableEl = $('#' + this.oattr);
        if (!tableEl.is(':visible')) {
            if (typeof this.columnWidthHandlerInterval === 'undefined') {
                this.columnWidthHandlerInterval = setInterval(function () {
                    if (tableEl.is(':visible')) {
                        clearInterval(self.columnWidthHandlerInterval);
                        self.columnWidthHandlerInterval = undefined;
                        self.handleColumnWidth(settings);
                        console.log('columnWidthHandlerInterval');
                    }
                }, 250);
            }
            return;
        }
        var api = $.fn.dataTable.Api(settings);
        var tableColumns = api.columns();
        var columnsNumber = tableColumns[0].length;
        var fixedWidthColumns = 0;
        fixedWidthColumns += (this.selectAllCheckbox ? 1 : 0);
        var actionColumns = 0;
        actionColumns += (this.editColumnIndex !== -1 ? 1 : 0);
        actionColumns += (this.detailColumnIndex !== -1 ? 1 : 0);
        fixedWidthColumns += actionColumns;
        var tableWidth = tableEl.outerWidth(true);
        var actionsWidth = ((fixedWidthColumns * 50) / tableWidth) * 100;
        var avoidIndex = [];
        var fixedWidths = 0;
        for (var i = 0; i < this.initialColumnsWidths.length; i++) {
            var colObj = this.initialColumnsWidths[i];
            var tableCol = api.column(colObj.name + ':name');
            if (tableCol) {
                avoidIndex.push(tableCol.index());
                var header = $(tableCol.header());
                header.width(colObj.width);
                fixedWidths += parseInt(colObj.width);
            }
        }
        var remainingColumns = columnsNumber - this.initialColumnsWidths.length - fixedWidthColumns;
        var calcWidth = String((100 - actionsWidth - fixedWidths) / (remainingColumns || 1)) + '%';
        tableColumns.every(function (i) {
            if (avoidIndex.indexOf(i) === -1) {
                var columnWidth = '0px';
                var isActionColumn = (i >= (columnsNumber - actionColumns));
                if (self.selectAllCheckbox && i === 0) {
                    columnWidth = '26px';
                }
                else if (!isActionColumn) {
                    columnWidth = calcWidth;
                }
                else {
                    columnWidth = '2px';
                }
                $(api.columns(i).header()).width(columnWidth);
            }
        });
    };
    ODataTableComponent.prototype.handleOrderIndex = function () {
        var header = $('#' + this.oattr + '_wrapper table thead');
        header.find('.sorting-index').remove();
        var order = this.table.order();
        for (var i = 0; i < order.length; ++i) {
            var orderItem = order[i];
            header.find('th[data-column-index="' + orderItem[0] + '"]').append('<div class="sorting-index">' + (i + 1) + '</div>');
        }
    };
    ODataTableComponent.prototype.select = function (item) {
        this.table.rows().deselect();
        this.selectedItems = [item];
    };
    ODataTableComponent.prototype.handleSelection = function (event, dt, type, indexes) {
        var localStorageState = localStorage.getItem('DataTables' + '_' + this.oattr + '_' + this.router.url);
        if (localStorageState) {
            var state = JSON.parse(localStorageState);
            state.selectedIndex = indexes[0];
            localStorage.setItem('DataTables' + '_' + this.oattr + '_' + this.router.url, JSON.stringify(state));
            var selection = this.table.rows(indexes).data().toArray();
            for (var i = 0; i < selection.length; ++i) {
                var selected = false;
                for (var j = this.selectedItems.length; j >= 0; --j) {
                    if (selection[i] === this.selectedItems[j]) {
                        selected = true;
                        break;
                    }
                }
                if (!selected) {
                    this.selectedItems.push(selection[i]);
                }
            }
            this.updateDeleteButtonState();
            if (!this.isProgrammaticSelection) {
                ObservableWrapper.callEmit(this.onRowSelected, selection);
            }
        }
    };
    ODataTableComponent.prototype.updateDeleteButtonState = function () {
        var deleteButton = $('#' + this.oattr + '_wrapper .generic-action-delete');
        if (this.selectedItems.length > 0) {
            deleteButton.removeClass('disabled');
        }
        else {
            deleteButton.addClass('disabled');
        }
    };
    ODataTableComponent.prototype.handleDeselection = function (event, dt, type, indexes) {
        this.lastDeselection = {
            event: event,
            dt: dt,
            type: type,
            indexes: indexes
        };
        var localStorageState = localStorage.getItem('DataTables' + '_' + this.oattr + '_' + this.router.url);
        if (localStorageState) {
            var state = JSON.parse(localStorageState);
            delete state.selectedIndex;
            localStorage.setItem('DataTables' + '_' + this.oattr + '_' + this.router.url, JSON.stringify(state));
        }
        var selection = this.table.rows(indexes).data().toArray();
        for (var i = 0; i < selection.length; ++i) {
            for (var j = this.selectedItems.length; j >= 0; --j) {
                if (selection[i] === this.selectedItems[j]) {
                    this.selectedItems.splice(j, 1);
                    break;
                }
            }
        }
        this.updateDeleteButtonState();
        if (!this.isProgrammaticSelection) {
            ObservableWrapper.callEmit(this.onRowDeselected, selection);
        }
    };
    ODataTableComponent.prototype.handleSelectAllClick = function (event) {
        this.setSelectAllCheckboxValue(event.target.checked);
    };
    ODataTableComponent.prototype.setSelectAllCheckboxValue = function (val) {
        if (this.selectAllCheckbox) {
            var headerCheckboxCol = this.tableHtmlEl.find('th.o-table-column-select-checkbox');
            var wasIndeterminate = headerCheckboxCol.hasClass('mat-checkbox-indeterminate');
            headerCheckboxCol.attr('class', 'o-table-column-select-checkbox');
            if (val) {
                headerCheckboxCol.addClass('mat-checkbox-checked mat-checkbox-anim-unchecked-checked');
            }
            else if (wasIndeterminate) {
                headerCheckboxCol.addClass('mat-checkbox-anim-indeterminate-unchecked');
            }
            else {
                headerCheckboxCol.addClass('mat-checkbox-anim-checked-unchecked');
            }
            var self = this;
            this.table.rows({ filter: 'applied' }).every(function (el) {
                var checkboxEl = self.table.row(el).node().querySelector('input[type="checkbox"].select-row');
                if (checkboxEl) {
                    checkboxEl.checked = val;
                    $(checkboxEl).change();
                }
            });
        }
    };
    ODataTableComponent.prototype.selectRowsByData = function (data, value) {
        if (value === void 0) { value = true; }
        this.isProgrammaticSelection = true;
        var rowsSelectors = [];
        var _loop_1 = function () {
            var current = data[i];
            var currentSelector = {};
            this_1.keysArray.forEach(function (key) { return currentSelector[key] = current[key]; });
            rowsSelectors.push(currentSelector);
        };
        var this_1 = this;
        for (var i = 0; i < data.length; i++) {
            _loop_1();
        }
        if (this.table && rowsSelectors.length) {
            var self = this;
            var alterRowIndexes_1 = [];
            this.table.rows({ filter: 'applied' }).eq(0).each(function (index) {
                var row = self.table.row(index);
                var rowData = row.data();
                rowsSelectors.forEach(function (selectorObj) {
                    var props = Object.keys(selectorObj);
                    var alterRow = true;
                    for (var i = 0; i < props.length; i++) {
                        alterRow = alterRow && (selectorObj[props[i]] === rowData[props[i]]);
                    }
                    if (alterRow && self.selectAllCheckbox) {
                        var checkboxEl = row.node().querySelector('input[type="checkbox"].select-row');
                        if (checkboxEl) {
                            checkboxEl.checked = value;
                            $(checkboxEl).change();
                        }
                    }
                    else if (alterRow) {
                        alterRowIndexes_1.push(index);
                    }
                });
            });
            if (!this.selectAllCheckbox && alterRowIndexes_1.length) {
                if (value) {
                    this.table.rows(alterRowIndexes_1).select();
                }
                else {
                    this.table.rows(alterRowIndexes_1).deselect();
                }
            }
        }
        this.isProgrammaticSelection = false;
    };
    ODataTableComponent.prototype.handleRowCheckboxChange = function (event) {
        var rowEL = $(event.target).parents('tr:first');
        var checkBoxColumn = rowEL.find('.o-table-column-select-checkbox:first');
        checkBoxColumn.attr('class', 'o-table-column-select-checkbox');
        var tableRow = this.table.rows(rowEL);
        var rowData = tableRow.data().toArray()[0];
        if (event.target.checked) {
            checkBoxColumn.addClass('mat-checkbox-checked mat-checkbox-anim-unchecked-checked');
            tableRow.select();
            this.selectedItems.push(rowData);
        }
        else {
            checkBoxColumn.addClass('mat-checkbox-anim-checked-unchecked');
            tableRow.deselect();
            this.selectedItems.splice(this.selectedItems.indexOf(rowData), 1);
            var selectAllEL = this.tableHtmlEl.find('th #select_all')[0];
            if (selectAllEL && selectAllEL.checked && ('indeterminate' in selectAllEL)) {
                selectAllEL.indeterminate = true;
                var headerCheckboxCol = this.tableHtmlEl.find('th.o-table-column-select-checkbox');
                headerCheckboxCol.attr('class', 'o-table-column-select-checkbox');
                headerCheckboxCol.addClass('mat-checkbox-indeterminate mat-checkbox-anim-checked-indeterminate');
            }
        }
        this.updateDeleteButtonState();
        if (!this.isProgrammaticSelection && event.target.checked) {
            ObservableWrapper.callEmit(this.onRowSelected, rowData);
        }
        else if (!this.isProgrammaticSelection) {
            ObservableWrapper.callEmit(this.onRowDeselected, rowData);
        }
    };
    ODataTableComponent.prototype.handleClick = function (event) {
        var item = this.table.row(event.target).data();
        ObservableWrapper.callEmit(this.onClick, item);
        var cellEl = $(this.table.cell(event.target).nodes());
        if (this.oenabled && (this.detailMode === 'click') && !cellEl.hasClass('editable')) {
            this.viewDetail(item);
        }
    };
    ODataTableComponent.prototype.handleDoubleClick = function (event) {
        var item = this.table.row(event.target).data();
        ObservableWrapper.callEmit(this.onClick, item);
        var cellEl = $(this.table.cell(event.target).nodes());
        cellEl.addClass('noselect');
        if (this.oenabled && (this.detailMode === 'doubleclick') && !cellEl.hasClass('editable')) {
            this.viewDetail(item);
        }
        cellEl.removeClass('noselect');
    };
    ODataTableComponent.prototype.initColumnResize = function () {
        if (typeof (this.tableHtmlEl) !== 'undefined') {
            var disabledResizeColumns = [];
            if (this.selectAllCheckbox) {
                disabledResizeColumns.push(0);
            }
            if (this.editButtonInRow) {
                disabledResizeColumns.push(this.editColumnIndex);
                if (disabledResizeColumns.indexOf(this.editColumnIndex - 1) === -1) {
                    disabledResizeColumns.push(this.editColumnIndex - 1);
                }
            }
            if (this.detailButtonInRow) {
                disabledResizeColumns.push(this.detailColumnIndex);
                if (disabledResizeColumns.indexOf(this.detailColumnIndex - 1) === -1) {
                    disabledResizeColumns.push(this.detailColumnIndex - 1);
                }
            }
            $('#' + this.oattr + '_wrapper .JCLRgrips').remove();
            if (!this.tableHtmlEl.colResizable) {
                console.error('colResizable not defined');
                return;
            }
            this.tableHtmlEl.colResizable({
                liveDrag: false,
                postbackSafe: false,
                partialRefresh: true,
                minWidth: 50,
                disabledColumns: disabledResizeColumns
            });
        }
    };
    ODataTableComponent.prototype.initColumnGroup = function () {
        var _this = this;
        var header = this.tableHtmlEl.find('th');
        header.on('click', function (event) {
            if (event.isPropagationStopped()) {
                return;
            }
            event.stopPropagation();
            var groupButton = $('#' + _this.oattr + '_wrapper .generic-action-group');
            if (groupButton.hasClass('active')) {
                header.removeClass('group');
                var th = $(event.target);
                var order = _this.table.order();
                var columnIndex = parseInt(th.attr('data-column-index'));
                if (_this.groupColumnIndex === columnIndex) {
                    if ((order[0][0] === _this.groupColumnIndex) && (order[0][1] === ODataTableComponent.TYPE_ASC_NAME)) {
                        _this.groupColumnOrder = ODataTableComponent.TYPE_DESC_NAME;
                        order[0][1] = _this.groupColumnOrder;
                        th.addClass('group');
                    }
                    else {
                        order = order.slice(1);
                        _this.groupColumnIndex = -1;
                    }
                }
                else {
                    if (_this.groupColumnIndex !== -1) {
                        order = order.slice(1);
                    }
                    _this.groupColumnIndex = columnIndex;
                    _this.groupColumnOrder = ODataTableComponent.TYPE_ASC_NAME;
                    var orderByGroupColumn = true;
                    for (var i = 0; i < order.length; ++i) {
                        if (order[i][0] === _this.groupColumnIndex) {
                            orderByGroupColumn = false;
                            break;
                        }
                    }
                    if (orderByGroupColumn) {
                        order.unshift([_this.groupColumnIndex, _this.groupColumnOrder]);
                    }
                    th.addClass('group');
                }
                _this.table.order(order);
                _this.dataTable.fnDraw();
                var emptyRow = $('.dataTables_empty');
                if (emptyRow.length > 0) {
                    emptyRow.parent().addClass('empty');
                }
            }
        });
    };
    ODataTableComponent.prototype.update = function (parentItem, ovrrArgs) {
        if (parentItem === void 0) { parentItem = undefined; }
        this.queryData(parentItem, ovrrArgs);
    };
    ODataTableComponent.prototype.queryData = function (parentItem, ovrrArgs) {
        if (parentItem === void 0) { parentItem = undefined; }
        if (!this.initialized) {
            this.pendingQuery = true;
            this.pendingQueryFilter = parentItem;
            return;
        }
        var queryMethodName = this.pageable ? this.paginatedQueryMethod : this.queryMethod;
        if (this.dataService && (queryMethodName in this.dataService) && this.entity) {
            this.pendingQuery = false;
            this.pendingQueryFilter = undefined;
            if (typeof (this.dataTable) !== 'undefined' && !this.pageable) {
                this.dataTable.fnClearTable(false);
            }
            if (this.filterForm && (typeof (parentItem) === 'undefined')) {
                parentItem = {};
                var formComponents = this.form.getComponents();
                if ((this.dataParentKeys.length > 0) && (Object.keys(formComponents).length > 0)) {
                    for (var k = 0; k < this.dataParentKeys.length; ++k) {
                        var parentKey = this.dataParentKeys[k];
                        if (formComponents.hasOwnProperty(parentKey['alias'])) {
                            var currentData = formComponents[parentKey['alias']].getValue();
                            switch (typeof (currentData)) {
                                case 'string':
                                    if (currentData.trim().length > 0) {
                                        parentItem[parentKey['alias']] = currentData.trim();
                                    }
                                    break;
                                case 'number':
                                    if (!isNaN(currentData)) {
                                        parentItem[parentKey['alias']] = currentData;
                                    }
                                    break;
                            }
                        }
                    }
                }
            }
            if ((this.dataParentKeys.length > 0) && (typeof (parentItem) === 'undefined')) {
                this.dataArray = [];
                this.dataTable.fnClearTable(false);
                this.dataTable.fnDraw();
                var emptyRow = $('.dataTables_empty');
                if (emptyRow.length > 0) {
                    emptyRow.parent().addClass('empty');
                }
            }
            else {
                var filter = {};
                if ((this.dataParentKeys.length > 0) && (typeof (parentItem) !== 'undefined')) {
                    for (var k = 0; k < this.dataParentKeys.length; ++k) {
                        var parentKey = this.dataParentKeys[k];
                        if (parentItem.hasOwnProperty(parentKey['alias'])) {
                            var currentData = parentItem[parentKey['alias']];
                            if (currentData instanceof OFormValue) {
                                currentData = currentData.value;
                            }
                            filter[parentKey['name']] = currentData;
                        }
                    }
                }
                if (this.querySuscription) {
                    this.querySuscription.unsubscribe();
                    this.loaderSuscription.unsubscribe();
                }
                this.loaderSuscription = this.load();
                var queryArguments = this.getQueryArguments(filter, ovrrArgs);
                var self = this;
                this.querySuscription = this.dataService[queryMethodName].apply(this.dataService, queryArguments)
                    .subscribe(function (res) {
                    var data = undefined;
                    if (Util.isArray(res)) {
                        data = res;
                    }
                    else if ((res.code === 0) && Util.isArray(res.data)) {
                        data = (res.data !== undefined) ? res.data : [];
                        if (self.pageable) {
                            self.updatePaginationInfo(res);
                        }
                    }
                    if (Util.isArray(data)) {
                        self.dataTable.fnClearTable(false);
                        if (self.pageable) {
                            self.setPaginatedTableData(data, ovrrArgs);
                        }
                        else {
                            self.dataArray = data;
                        }
                        if (self.dataArray.length > 0) {
                            self.dataTable.fnAddData(self.dataArray);
                        }
                        if (self.table && self.pageable) {
                            var pagesInfo = self.table.page.info();
                            var activePage = pagesInfo.pages > 0 ? (pagesInfo.pages - 1) : 0;
                            if (!self.singlePageMode && ovrrArgs && ovrrArgs.hasOwnProperty('resultRecordsIndex')) {
                                activePage = Math.floor((ovrrArgs['resultRecordsIndex'] / self.queryRows));
                            }
                            self.table.page(activePage).draw(false);
                            self.updatePaginationFooterText(true);
                        }
                        else {
                            self.dataTable.fnDraw();
                        }
                        var emptyRow = $('.dataTables_empty');
                        if (emptyRow.length > 0) {
                            emptyRow.parent().addClass('empty');
                        }
                        self.selectedItems = [];
                        if (typeof (self.state.selectedIndex) !== 'undefined') {
                            var selectedRow = self.table.rows(self.state.selectedIndex);
                            var selectedRowData = selectedRow.data().toArray()[0];
                            if (self.selectedItems.indexOf(selectedRowData) === -1) {
                                self.selectedItems.push(selectedRowData);
                            }
                        }
                        self.updateDeleteButtonState();
                    }
                    else {
                        console.log('[ODataTable.queryData]: error code ' + res.code + ' when querying data');
                        self.setDataArray([]);
                        self.dataTable.fnClearTable(true);
                    }
                    self.loaderSuscription.unsubscribe();
                    if (self.pageable) {
                        ObservableWrapper.callEmit(self.onPaginatedTableDataLoaded, data);
                    }
                    ObservableWrapper.callEmit(self.onTableDataLoaded, self.dataArray);
                }, function (err) {
                    console.log('[ODataTable.queryData]: error', err);
                    self.setDataArray([]);
                    self.dataTable.fnClearTable(true);
                    self.loaderSuscription.unsubscribe();
                });
            }
        }
    };
    ODataTableComponent.prototype.setPaginatedTableData = function (data, ovrrArgs) {
        var parsedDataArray = [];
        if (this.singlePageMode) {
            parsedDataArray = data;
        }
        else if (ovrrArgs && ovrrArgs.hasOwnProperty('resultRecordsIndex')) {
            var initIndex = ovrrArgs['resultRecordsIndex'];
            var endIndex = (ovrrArgs && ovrrArgs['replace']) ? ovrrArgs['resultRecordsIndex'] + data.length : ovrrArgs['resultRecordsIndex'];
            var removeRowsIdx = [];
            if (ovrrArgs && ovrrArgs['replace']) {
                for (var ri = initIndex; ri < endIndex; ri++) {
                    removeRowsIdx.push(ri);
                }
            }
            if (removeRowsIdx.length) {
                this.dataTable.fnDeleteRow(removeRowsIdx, undefined, false);
            }
            parsedDataArray = this.dataArray.slice(0, initIndex).concat(data).concat(this.dataArray.slice(endIndex));
        }
        else {
            parsedDataArray = this.dataArray.concat(data);
        }
        this.dataArray = parsedDataArray;
    };
    ODataTableComponent.prototype.updatePaginationInfo = function (queryRes) {
        _super.prototype.updatePaginationInfo.call(this, queryRes);
        if (!this.singlePageMode) {
            this.storedRecordsIndexes.push({
                start: queryRes.startRecordIndex,
                end: queryRes.startRecordIndex + (queryRes.data ? queryRes.data.length : 0)
            });
        }
    };
    ODataTableComponent.prototype.areRecordsLoaded = function (startIndex, endIndex) {
        var result = false;
        for (var i = 0; i < this.storedRecordsIndexes.length; i++) {
            var storedStart = this.storedRecordsIndexes[i].start;
            var storedEnd = this.storedRecordsIndexes[i].end;
            if ((startIndex >= storedStart && startIndex <= storedEnd)
                && (endIndex >= storedStart && endIndex <= storedEnd)) {
                return true;
            }
        }
        return result;
    };
    ODataTableComponent.prototype.updatePaginationFooterText = function (redraw) {
        var tableWrapperEl = this.tableHtmlEl.parents('.dataTables_wrapper:first');
        if (tableWrapperEl.length === 0 || !redraw) {
            return;
        }
        var footerTextEl = tableWrapperEl.find('.dataTables_pagination_wrapper .dataTables_info');
        if (footerTextEl && footerTextEl.length && this.state.queryTotalRecordNumber > 0) {
            var existingText = footerTextEl.text().trim();
            var tableSettings = this.table.settings();
            var isFiltering = ((tableSettings.search() || '').length > 0);
            var initIndex = (this.state.queryRecordOffset - this.queryRows) + 1;
            initIndex = initIndex <= 0 ? 1 : initIndex;
            var endIndex = (this.state.queryRecordOffset < this.state.queryTotalRecordNumber) ? (initIndex + this.queryRows - 1) : this.state.queryRecordOffset;
            if (isFiltering) {
                endIndex = this.table.rows({ filter: 'applied' })[0].length;
            }
            var newText = initIndex + ' - ' + endIndex + ' ';
            var match = existingText.match('[0-9]+ - [0-9]+');
            var initTrimIdx = existingText.search('\d');
            if (match && match.length === 1) {
                initTrimIdx = match[0].length + 1;
            }
            if (isFiltering) {
                newText += ' ' + existingText.substring(initTrimIdx);
            }
            else {
                newText += existingText.substring(initTrimIdx, existingText.lastIndexOf(' '));
                newText += ' ' + this.state.queryTotalRecordNumber;
            }
            footerTextEl.text(newText);
        }
    };
    ODataTableComponent.prototype.updatePageableTable = function (redraw) {
        if (!this.table || !this.pageable) {
            return;
        }
        var tableWrapperEl = this.tableHtmlEl.parents('.dataTables_wrapper:first');
        var existingRows = this.dataArray.length;
        if (tableWrapperEl.length === 0 || existingRows === 0) {
            return;
        }
        this.updatePaginationFooterText(redraw);
        var currentPageInfo = this.table.page.info();
        var self = this;
        var tableState = this.state;
        var activateNextBtns = (tableState.queryRecordOffset < tableState.queryTotalRecordNumber);
        if (activateNextBtns) {
            var nextBtn = tableWrapperEl.find('.dataTables_pagination_wrapper .next');
            if (nextBtn) {
                nextBtn.removeClass('disabled').off('click').one('click', function () {
                    var pagesInfo = self.table.page.info();
                    var newStartRecord = Math.max(tableState.queryRecordOffset, pagesInfo.end);
                    var newEndRecord = Math.min(newStartRecord + self.queryRows, tableState.queryTotalRecordNumber);
                    var queryLength = Math.min(self.queryRows, newEndRecord - newStartRecord);
                    var areRecordsLoaded = self.areRecordsLoaded(newStartRecord, newEndRecord);
                    if (!areRecordsLoaded) {
                        var queryArgs = {
                            offset: newStartRecord,
                            length: queryLength,
                            resultRecordsIndex: Math.min(newStartRecord, self.dataArray.length)
                        };
                        self.queryData(self.parentItem, queryArgs);
                    }
                    else {
                        tableState.queryRecordOffset = newEndRecord;
                        self.table.page('next').draw(false);
                        self.updatePaginationFooterText(true);
                    }
                });
            }
            var lastBtn = tableWrapperEl.find('.dataTables_pagination_wrapper .last');
            if (lastBtn) {
                lastBtn.removeClass('disabled').off('click').one('click', function () {
                    var lastPageRows = (tableState.queryTotalRecordNumber % self.queryRows) || self.queryRows;
                    var newStartRecord = tableState.queryTotalRecordNumber - lastPageRows;
                    var newEndRecord = newStartRecord + lastPageRows;
                    var areRecordsLoaded = self.areRecordsLoaded(newStartRecord, newEndRecord);
                    if (!areRecordsLoaded) {
                        var queryArgs = {
                            offset: newStartRecord,
                            length: lastPageRows
                        };
                        self.queryData(self.parentItem, queryArgs);
                    }
                    else {
                        tableState.queryRecordOffset = newEndRecord;
                        self.table.page('last').draw(false);
                        self.updatePaginationFooterText(true);
                    }
                });
            }
        }
        var activatePrevBtns = self.singlePageMode ? tableState.queryRecordOffset > self.queryRows : (currentPageInfo.page > 0 || !self.areRecordsLoaded(0, 0));
        if (activatePrevBtns) {
            var prevBtn = tableWrapperEl.find('.dataTables_pagination_wrapper .previous');
            if (prevBtn) {
                prevBtn.removeClass('disabled').off('click').one('click', function () {
                    var pagesInfo = self.table.page.info();
                    var newStartRecord = (Math.max(tableState.queryRecordOffset - (pagesInfo.end - pagesInfo.start), pagesInfo.start) - self.queryRows);
                    var newEndRecord = newStartRecord + self.queryRows;
                    var areRecordsLoaded = self.areRecordsLoaded(newStartRecord, newEndRecord);
                    if (!areRecordsLoaded) {
                        var queryArgs = {
                            offset: newStartRecord,
                            length: self.queryRows,
                            resultRecordsIndex: Math.min(newStartRecord, self.dataArray.length - (tableState.queryTotalRecordNumber - newEndRecord))
                        };
                        self.queryData(self.parentItem, queryArgs);
                    }
                    else {
                        tableState.queryRecordOffset = newEndRecord;
                        self.table.page('previous').draw(false);
                        self.updatePaginationFooterText(true);
                    }
                });
            }
            var firstBtn = tableWrapperEl.find('.dataTables_pagination_wrapper .first');
            if (firstBtn) {
                firstBtn.removeClass('disabled').off('click').one('click', function () {
                    var areRecordsLoaded = self.areRecordsLoaded(0, self.queryRows);
                    if (!areRecordsLoaded) {
                        var queryArgs = {
                            offset: 0,
                            length: self.queryRows,
                            resultRecordsIndex: 0
                        };
                        self.queryData(self.parentItem, queryArgs);
                    }
                    else {
                        tableState.queryRecordOffset = self.queryRows;
                        self.table.page('first').draw(false);
                        self.updatePaginationFooterText(true);
                    }
                });
            }
        }
    };
    ODataTableComponent.prototype.remove = function (clearSelectedItems) {
        var _this = this;
        if (clearSelectedItems === void 0) { clearSelectedItems = false; }
        if ((this.keysArray.length > 0) && (this.selectedItems.length > 0)) {
            this.dialogService.confirm('CONFIRM', 'MESSAGES.CONFIRM_DELETE')
                .then(function (res) {
                if (res === true) {
                    if (_this.dataService && (_this.deleteMethod in _this.dataService) && _this.entity && (_this.keysArray.length > 0)) {
                        var filters_1 = [];
                        _this.selectedItems.map(function (item) {
                            var kv = {};
                            for (var k = 0; k < _this.keysArray.length; ++k) {
                                var key = _this.keysArray[k];
                                kv[key] = item[key];
                            }
                            filters_1.push(kv);
                        });
                        var observable = Observable.from(filters_1)
                            .map(function (kv) { return _this.dataService[_this.deleteMethod](kv, _this.entity); }).mergeAll();
                        observable.subscribe(function (res) {
                            console.log('[ODataTable.remove]: response', res);
                            ObservableWrapper.callEmit(_this.onRowDeleted, _this.selectedItems);
                        }, function (error) {
                            console.log('[ODataTable.remove]: error', error);
                            _this.dialogService.alert('ERROR', 'MESSAGES.ERROR_DELETE');
                        }, function () {
                            console.log('[ODataTable.remove]: success');
                            _this.setTableInitialState();
                            var queryArgs = {
                                offset: 0,
                                length: _this.queryRows
                            };
                            _this.queryData(_this.parentItem, queryArgs);
                        });
                    }
                    else {
                        _this.deleteLocalItems();
                        _this.updateDeleteButtonState();
                        _this.dataTable.fnClearTable(false);
                        if (_this.dataArray.length > 0) {
                            _this.dataTable.fnAddData(_this.dataArray);
                        }
                        _this.dataTable.fnDraw();
                        var emptyRow = $('.dataTables_empty');
                        if (emptyRow.length > 0) {
                            emptyRow.parent().addClass('empty');
                        }
                        ObservableWrapper.callEmit(_this.onRowDeleted, _this.selectedItems);
                    }
                }
                else if (clearSelectedItems) {
                    _this.selectedItems = [];
                }
            });
        }
    };
    ODataTableComponent.prototype.add = function () {
        var route = [];
        if (this.detailFormRoute) {
            route.push(this.detailFormRoute);
        }
        route.push('new');
        if ((this.dataParentKeys.length > 0) && (typeof (this.parentItem) !== 'undefined')) {
            var pKeys = {};
            for (var k = 0; k < this.dataParentKeys.length; ++k) {
                var parentKey = this.dataParentKeys[k];
                if (this.parentItem.hasOwnProperty(parentKey['alias'])) {
                    var currentData = this.parentItem[parentKey['alias']];
                    if (currentData instanceof OFormValue) {
                        currentData = currentData.value;
                    }
                    pKeys[parentKey['name']] = currentData;
                }
            }
            if (Object.keys(pKeys).length > 0) {
                var encoded = Util.encodeParentKeys(pKeys);
                route.push({ 'pk': encoded });
            }
        }
        var extras = { relativeTo: this.actRoute };
        this.router.navigate(route, extras).catch(function (err) {
            console.error(err.message);
        });
    };
    ODataTableComponent.prototype.getTableOptions = function () {
        var options = [];
        var self = this;
        var columnsSelector = ':visible:not(.o-table-select-checkbox):not(.o-table-column-action)';
        if (this.exportButton) {
            options.push({
                extend: 'copyHtml5',
                name: 'copyHtml5',
                text: this.translateService.get('TABLE.BUTTONS.COPY_TO_CLIPBOARD'),
                className: 'export-action',
                exportOptions: {
                    columns: columnsSelector
                }
            });
            options.push({
                extend: 'print',
                name: 'print',
                text: this.translateService.get('TABLE.BUTTONS.PRINT'),
                className: 'export-action',
                exportOptions: {
                    columns: columnsSelector
                }
            });
            options.push({
                extend: 'excelHtml5',
                text: 'Excel',
                name: 'excel',
                className: 'export-action',
                filename: this.title ? this.title : '*',
                exportOptions: {
                    columns: columnsSelector
                }
            });
            options.push({
                extend: 'csvHtml5',
                text: 'CSV',
                name: 'csv',
                className: 'export-action',
                filename: this.title ? this.title : '*',
                fieldSeparator: ',',
                extension: '.csv',
                exportOptions: {
                    columns: columnsSelector
                }
            });
            options.push({
                extend: 'pdfHtml5',
                text: 'PDF',
                name: 'pdf',
                className: 'export-action',
                filename: this.title ? this.title : '*',
                title: this.title ? this.title : '*',
                orientation: 'portrait',
                pageSize: 'A4',
                exportOptions: {
                    columns: columnsSelector,
                    orthogonal: 'export'
                }
            });
            options.push({
                text: this.translateService.get('TABLE.BUTTONS.EXPORT'),
                className: 'generic-action generic-action-export',
                action: function () {
                    self.exportButtonAction();
                }
            });
        }
        if (this.columnsGroupButton) {
            options.push({
                text: this.translateService.get('TABLE.BUTTONS.GROUP_ROWS'),
                className: 'generic-action generic-action-group',
                action: function () {
                    self.columnsGroupButtonAction();
                }
            });
        }
        if (this.columnsResizeButton) {
            options.push({
                text: this.translateService.get('TABLE.BUTTONS.RESIZE_COLUMNS'),
                className: 'generic-action generic-action-resize',
                action: function () {
                    self.columnsResizeButtonAction();
                }
            });
        }
        if (this.columnsVisibilityButton) {
            var colVisOptions = {
                extend: 'colvis',
                text: this.translateService.get('TABLE.BUTTONS.COLVIS'),
                className: 'generic-action generic-action-view-column',
                collectionLayout: 'fixed',
                columns: []
            };
            for (var i = 0; i < this.visibleColumnsArray.length; i++) {
                colVisOptions.columns.push(this.visibleColumnsArray[i] + ':name');
            }
            options.push(colVisOptions);
        }
        return options;
    };
    ODataTableComponent.prototype.exportButtonAction = function () {
        this.showExportOptions = !this.showExportOptions;
    };
    ODataTableComponent.prototype.columnsGroupButtonAction = function () {
        var header = this.tableHtmlEl.find('th');
        var groupButton = $('#' + this.oattr + '_wrapper .generic-action-group');
        if (groupButton.hasClass('active')) {
            groupButton.removeClass('active');
            header.removeClass('grouping');
            this.dataTable.fnSortOnOff('_all', true);
        }
        else {
            groupButton.addClass('active');
            header.addClass('grouping');
            this.dataTable.fnSortOnOff('_all', false);
        }
    };
    ODataTableComponent.prototype.columnsResizeButtonAction = function () {
        var resizeButton = $('#' + this.oattr + '_wrapper .generic-action-resize');
        if (resizeButton.hasClass('active')) {
            resizeButton.removeClass('active');
            $('#' + this.oattr + '_wrapper .JCLRgrips').remove();
        }
        else {
            resizeButton.addClass('active');
            this.initColumnResize();
        }
    };
    ODataTableComponent.prototype.columnsVisibilityButtonAction = function () {
        this.table.buttons('.generic-action-view-column').trigger();
    };
    ODataTableComponent.prototype.exportAction = function (buttonName) {
        this.table.buttons(buttonName + ':name').trigger();
    };
    ODataTableComponent.prototype.getTableButtons = function () {
        var _this = this;
        var buttons = [];
        var buttonTextClass = this.showTableButtonsText ? '' : ' hidden-action-text';
        if (this.insertButton) {
            buttons.push({
                text: this.translateService.get('TABLE.BUTTONS.ADD'),
                className: 'generic-action generic-action-add' + buttonTextClass,
                action: function () {
                    _this.add();
                }
            });
        }
        if (this.deleteButton) {
            buttons.push({
                text: this.translateService.get('TABLE.BUTTONS.DELETE'),
                className: 'generic-action generic-action-delete disabled' + buttonTextClass,
                action: function () {
                    _this.remove();
                }
            });
        }
        if (this.refreshButton) {
            buttons.push({
                text: this.translateService.get('TABLE.BUTTONS.REFRESH'),
                className: 'generic-action generic-action-refresh' + buttonTextClass,
                action: function () {
                    _this.reloadData();
                }
            });
        }
        for (var i = 0; i < this.headerButtons.length; i++) {
            var headerBtn = this.headerButtons[i];
            buttons.push({
                text: this.translateService.get(headerBtn.getLabel()),
                className: 'custom-generic-action icon-' + headerBtn.getIcon() + buttonTextClass,
                action: function () {
                    headerBtn.innerOnClick();
                }
            });
        }
        return buttons;
    };
    ODataTableComponent.prototype.getLanguageLabels = function () {
        var labels = {
            'emptyTable': this.translateService.get('TABLE.EMPTY'),
            'info': this.translateService.get('TABLE.INFO'),
            'infoEmpty': this.translateService.get('TABLE.INFO_EMPTY'),
            'infoFiltered': this.translateService.get('TABLE.INFO_FILTERED'),
            'infoPostFix': this.translateService.get('TABLE.INFO_POST_FIX'),
            'lengthMenu': this.translateService.get('TABLE.LENGTH_MENU'),
            'loadingRecords': this.translateService.get('TABLE.LOADING_RECORDS'),
            'processing': this.translateService.get('TABLE.PROCESSING'),
            'search': this.translateService.get('TABLE.SEARCH'),
            'zeroRecords': this.translateService.get('TABLE.ZERO_RECORDS'),
            'paginate': {
                'first': this.translateService.get('TABLE.PAGINATE.FIRST'),
                'last': this.translateService.get('TABLE.PAGINATE.LAST'),
                'next': this.translateService.get('TABLE.PAGINATE.NEXT'),
                'previous': this.translateService.get('TABLE.PAGINATE.PREVIOUS')
            },
            'aria': {
                'sortAscending': this.translateService.get('TABLE.ARIA.SORT_ASCENDING'),
                'sortDescending': this.translateService.get('TABLE.ARIA.SORT_DESCENDING')
            },
            'buttons': {
                'colvis': this.translateService.get('TABLE.BUTTONS.COLVIS'),
                'copyTitle': this.translateService.get('TABLE.BUTTONS.COPY_TITLE'),
                'copySuccess': {
                    '_': this.translateService.get('TABLE.BUTTONS.COPY_SUCCESS._'),
                    '1': this.translateService.get('TABLE.BUTTONS.COPY_SUCCESS.1')
                }
            },
            'select': {
                'rows': {
                    '_': this.translateService.get('TABLE.SELECT.ROWS._'),
                    '0': this.translateService.get('TABLE.SELECT.ROWS.0'),
                    '1': this.translateService.get('TABLE.SELECT.ROWS.1')
                }
            }
        };
        return labels;
    };
    ODataTableComponent.prototype.isColumnEditable = function (column) {
        return (this.editableColumnsArray.indexOf(column) !== -1);
    };
    ODataTableComponent.prototype.renderRowRenderers = function (cellElement, rowData) {
        var currentCols = this.table.settings()[0].aoColumns;
        var rowEl = $(this.table.row(cellElement).nodes());
        rowEl.removeClass('editRow');
        var rowCellsEl = rowEl.find('td');
        for (var i = 0; i < rowCellsEl.length; ++i) {
            var cellEl = $(rowCellsEl[i]);
            var colIndex = this.table.column(rowCellsEl[i]).index();
            if (colIndex < currentCols.length) {
                var colDef = currentCols[colIndex];
                if (colDef.editable) {
                    if (this.editOnFocus) {
                        cellEl.addClass('editable');
                    }
                    var data = rowData[colDef.name];
                    this.table.cell(rowCellsEl[i]).data(data);
                }
            }
        }
    };
    ODataTableComponent.prototype.renderRowEditors = function (cellElement) {
        var currentCols = this.table.settings()[0].aoColumns;
        var rowEl = $(this.table.row(cellElement).nodes());
        rowEl.addClass('editRow');
        var rowCellsEl = rowEl.find('td');
        for (var i = 0; i < rowCellsEl.length; ++i) {
            var cellEl = $(rowCellsEl[i]);
            cellEl.removeClass('editable focus');
            var cellData = this.table.cell(rowCellsEl[i]).data();
            var colIndex = this.table.column(rowCellsEl[i]).index();
            if (colIndex < currentCols.length) {
                var colDef = currentCols[colIndex];
                if (colDef.editable && (typeof (colDef.component) !== 'undefined') &&
                    (typeof (colDef.component.editor) !== 'undefined')) {
                    colDef.component.editor.createEditorForInsertTable(cellEl, cellData);
                }
                else {
                }
            }
            else {
            }
        }
    };
    ODataTableComponent.prototype.getRowEditorsAttrValues = function (cellElement) {
        var rowData = undefined;
        var currentCols = this.table.settings()[0].aoColumns;
        var rowEl = $(this.table.row(cellElement).nodes());
        var rowCellsEl = rowEl.find('td');
        for (var i = 0; i < rowCellsEl.length; ++i) {
            var colIndex = this.table.column(rowCellsEl[i]).index();
            if (colIndex < currentCols.length) {
                var colDef = currentCols[colIndex];
                if (colDef.editable && (typeof (colDef.component) !== 'undefined') &&
                    (typeof (colDef.component.editor) !== 'undefined')) {
                    var cellData = this.table.cell(rowCellsEl[i]).data();
                    var newData = colDef.component.editor.getInsertTableValue();
                    if (cellData !== newData) {
                        if (typeof (rowData) === 'undefined') {
                            rowData = {};
                        }
                        rowData[colDef.name] = newData;
                    }
                }
            }
        }
        return rowData;
    };
    ODataTableComponent.prototype.registerHeaderButton = function (button) {
        this.headerButtons.push(button);
    };
    ODataTableComponent.prototype.registerHeaderOption = function (option) {
        this.headerOptions.push(option);
    };
    ODataTableComponent.prototype.getRowDataFromColumn = function (tableColumn) {
        if (tableColumn && tableColumn.cellElement) {
            return this.table.row(tableColumn.cellElement).data();
        }
    };
    ODataTableComponent.prototype.getAvToInsertFromTableSettings = function (settings, includeParentKeys) {
        if (includeParentKeys === void 0) { includeParentKeys = true; }
        var av = {};
        for (var j = 0; j < settings.aoColumns.length; ++j) {
            var iColDef = settings.aoColumns[j];
            if (iColDef.bVisible && iColDef.editable && (typeof (iColDef.component) !== 'undefined') &&
                (typeof (iColDef.component.editor) !== 'undefined')) {
                var iName = iColDef.name;
                var iValue = iColDef.component.editor.getInsertTableValue();
                if (typeof (iValue) !== 'undefined') {
                    av[iName] = iValue;
                }
            }
        }
        if (includeParentKeys && (this.dataParentKeys.length > 0) && (typeof (this.parentItem) !== 'undefined')) {
            for (var k = 0; k < this.dataParentKeys.length; ++k) {
                var parentKey = this.dataParentKeys[k];
                if (this.parentItem.hasOwnProperty(parentKey['alias'])) {
                    var currentData = this.parentItem[parentKey['alias']];
                    if (currentData instanceof OFormValue) {
                        currentData = currentData.value;
                    }
                    av[parentKey['name']] = currentData;
                }
            }
        }
        return av;
    };
    ODataTableComponent.DEFAULT_INPUTS_O_DATATABLE = DEFAULT_INPUTS_O_DATATABLE;
    ODataTableComponent.DEFAULT_OUTPUTS_O_DATATABLE = DEFAULT_INPUTS_O_DATATABLE;
    ODataTableComponent.DEFAULT_DETAIL_ICON = 'search';
    ODataTableComponent.COLUMNS_SEPARATOR = ';';
    ODataTableComponent.COLUMNS_ALIAS_SEPARATOR = ':';
    ODataTableComponent.OPTIONS_SEPARATOR = ';';
    ODataTableComponent.VALUES_SEPARATOR = '=';
    ODataTableComponent.TYPE_SEPARATOR = ':';
    ODataTableComponent.TYPE_ASC_NAME = 'asc';
    ODataTableComponent.TYPE_DESC_NAME = 'desc';
    ODataTableComponent.DEFAULT_QUERY_ROWS_MENU = [
        [10, 25, 50, 100, -1],
        [10, 25, 50, 100, 'All']
    ];
    ODataTableComponent.ROW_BUTTON_DETAIL = 'DETAIL';
    ODataTableComponent.ROW_BUTTON_DELETE = 'DELETE';
    ODataTableComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-datatable',
                    template: "\n    <div *ngIf=\"loading\" class=\"spinner-container\" fxFlex=\"100\" fxLayout=\"row\" fxLayoutAlign=\"center center\">\n      <md-progress-spinner mode=\"indeterminate\">\n      </md-progress-spinner>\n    </div>\n\n    <div fxLayout=\"column\" class=\"expandable-container fill-remaining\" fxFill>\n      <div class=\"o-table-container\" *ngIf=\"isVisible()\" [class.disabled]=\"oenabled === false\" [class.detail]=\"detailMode !== 'none'\"\n        title=\"\">\n\n        <table [id]=\"getAttribute()\" [class]=\"rowHeight\"></table>\n\n        <button *ngIf=\"showOptionsButton\" class=\"o-table-menu-button\" md-icon-button [md-menu-trigger-for]=\"menu\">\n          <md-icon>more_vert</md-icon>\n        </button>\n\n        <md-menu #menu=\"mdMenu\" x-position=\"before\">\n          <!--<button *ngIf=\"exportButton\" md-menu-item (click)=\"exportButtonAction()\"> {{ 'TABLE.BUTTONS.EXPORT' | oTranslate }} </button>-->\n          <button *ngIf=\"exportButton || showExportOptions\" (click)=\"exportAction('copyHtml5')\" md-menu-item> {{ 'TABLE.BUTTONS.COPY_TO_CLIPBOARD' | oTranslate }} </button>\n          <button *ngIf=\"exportButton || showExportOptions\" (click)=\"exportAction('print')\" md-menu-item> {{ 'TABLE.BUTTONS.PRINT' | oTranslate }} </button>\n          <!--<button *ngIf=\"exportButton || showExportOptions\" (click)=\"exportAction('excel')\" md-menu-item> {{ 'TABLE.BUTTONS.EXCEL' | oTranslate }} </button>-->\n          <button *ngIf=\"exportButton || showExportOptions\" (click)=\"exportAction('csv')\" md-menu-item> {{ 'TABLE.BUTTONS.CSV' | oTranslate }} </button>\n          <button *ngIf=\"exportButton || showExportOptions\" (click)=\"exportAction('pdf')\" md-menu-item> {{ 'TABLE.BUTTONS.PDF' | oTranslate }} </button>\n\n\n          <button *ngIf=\"columnsGroupButton\" md-menu-item (click)=\"columnsGroupButtonAction()\"> {{ 'TABLE.BUTTONS.GROUP_ROWS' | oTranslate }} </button>\n          <button *ngIf=\"columnsResizeButton\" md-menu-item (click)=\"columnsResizeButtonAction()\"> {{ 'TABLE.BUTTONS.RESIZE_COLUMNS' | oTranslate }} </button>\n          <button *ngIf=\"columnsVisibilityButton\" md-menu-item (click)=\"columnsVisibilityButtonAction()\"> {{ 'TABLE.BUTTONS.COLVIS' | oTranslate }} </button>\n\n          <button md-menu-item *ngFor=\"let option of headerOptions\" (click)=\"option.innerOnClick($event)\">\n            <md-icon *ngIf=\"option.icon && option.iconPosition === 'before'\" class=\"mat-24\">{{ option.icon }}</md-icon>\n            {{ option.olabel | oTranslate }}\n            <md-icon *ngIf=\"option.icon && option.iconPosition === 'after'\" class=\"mat-24\" style=\"margin-left: 16px;\">{{ option.icon }}</md-icon>\n          </button>\n        </md-menu>\n\n      </div>\n    </div>\n  ",
                    styles: ["\n    .o-table{width:100%;height:100%;position:relative;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;box-sizing:border-box;-webkit-box-orient:horizontal;-webkit-box-direction:normal;-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;-webkit-box-align:center;-webkit-align-items:center;-ms-flex-align:center;align-items:center}.o-table .spinner-container{position:absolute;top:0px;left:0px;right:0px;bottom:0px;z-index:500;visibility:visible;opacity:1;-moz-transition:opacity 0.25s linear;-webkit-transition:opacity 0.25s linear;transition:opacity 0.25s linear}.o-table .spinner-container path{stroke-width:5px !important}.o-table .o-table-container{display:block;max-width:100%;height:100%;overflow:hidden;position:relative;margin:0 0.5%}.o-table .o-table-container.disabled .dt-buttons{display:none}.o-table .o-table-container.disabled thead tr::before{display:none}.o-table .o-table-container.disabled tbody tr:not(.group)::before{display:none}.o-table .o-table-container.disabled tbody tr.selected::before{display:none}.o-table .o-table-container.disabled tbody tr td.focus{outline:none}.o-table .o-table-container.disabled .dataTables_info .select-info{display:none}.o-table .o-table-container.detail tbody tr:not(.insertRow) td{cursor:pointer}.o-table .o-table-container .dt-buttons{margin:0 10px 0 4px}.o-table .o-table-container .dt-buttons a{text-decoration:none;outline:none;cursor:pointer;font-size:14px;display:inline-block;margin:0}.o-table .o-table-container .dt-buttons a:not(.hidden-action-text){padding-right:8px}.o-table .o-table-container .dt-buttons a:not(.hidden-action-text):not(.disabled):hover{border-radius:4px}.o-table .o-table-container .dt-buttons a.hidden-action-text:not(.disabled):hover{border-radius:50%}.o-table .o-table-container .dt-buttons .dt-button.active::after{border-radius:50%}.o-table .o-table-container .dt-buttons .dt-button.active>span{font-weight:bold}.o-table .o-table-container .dt-buttons .dt-button.disabled{cursor:not-allowed}.o-table .o-table-container .dt-buttons .dt-button.custom-generic-action::after{font-family:'Material Icons';content:attr(data-icon);font-size:24px;line-height:40px;padding:8px}.o-table .o-table-container .dt-buttons .dt-button.generic-action>span,.o-table .o-table-container .dt-buttons .dt-button.custom-generic-action>span{float:right;line-height:40px}.o-table .o-table-container .dt-buttons .dt-button.generic-action.hidden-action-text>span,.o-table .o-table-container .dt-buttons .dt-button.custom-generic-action.hidden-action-text>span{display:none}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-export{display:none}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-export::before{font-family:'Material Icons';content:\"file_download\";font-size:24px;margin:0px 5px;line-height:40px;padding:5px}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-group::before{font-family:'Material Icons';content:\"view_list\";font-size:24px;margin:0px 5px;line-height:40px;padding:5px}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-resize::before{font-family:'Material Icons';content:\"compare_arrows\";font-size:24px;margin:0px 5px;line-height:40px;padding:5px}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-view-column::before{font-family:'Material Icons';content:\"view_column\";font-size:24px;margin:0px 5px;line-height:40px;padding:5px}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-filter::before{font-family:'Material Icons';content:\"filter_list\";font-size:24px;margin:0px 5px;line-height:40px;padding:5px}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-refresh::before{font-family:'Material Icons';content:\"autorenew\";font-size:24px;line-height:40px;padding:8px}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-delete::before{font-family:'Material Icons';content:\"delete\";font-size:24px;line-height:40px;padding:8px}.o-table .o-table-container .dt-buttons .dt-button.generic-action.generic-action-add::before{font-family:'Material Icons';content:\"add\";font-size:24px;line-height:40px;padding:8px}.o-table .o-table-container .dt-buttons .dt-button.export-action{display:none}.o-table .o-table-container .dt-buttons .dt-button.export-action.buttons-copy>span,.o-table .o-table-container .dt-buttons .dt-button.export-action.buttons-print>span,.o-table .o-table-container .dt-buttons .dt-button.export-action.buttons-pdf>span{display:none}.o-table .o-table-container .dt-buttons .dt-button.export-action.buttons-excel>span,.o-table .o-table-container .dt-buttons .dt-button.export-action.buttons-csv>span{font-weight:bold;margin:0px 5px;vertical-align:6px}.o-table .o-table-container .dt-buttons .dt-button.export-action.buttons-copy::after{font-family:'Material Icons';content:\"content_copy\";font-size:24px;margin:0px 5px;line-height:40px;padding:5px}.o-table .o-table-container .dt-buttons .dt-button.export-action.buttons-print::after{font-family:'Material Icons';content:\"print\";font-size:24px;margin:0px 5px;line-height:40px;padding:5px}.o-table .o-table-container .dt-buttons .dt-button.export-action.buttons-pdf::after{font-family:'Material Icons';content:\"picture_as_pdf\";font-size:24px;margin:0px 5px;line-height:40px;padding:5px}.o-table .o-table-container .dt-buttons .dt-button.buttons-columnVisibility{display:none;float:left;margin:10px 4px 10px 8px;font-size:14px}.o-table .o-table-container .dataTables_hidden_options{width:75%;float:left;text-align:right;display:none}.o-table .o-table-container .dataTables_filter{margin:0px;padding:0px 75px 0 50px;height:40px;min-width:250px;width:25%;float:right;box-sizing:border-box}.o-table .o-table-container .dataTables_filter label{position:relative;vertical-align:top}.o-table .o-table-container .dataTables_filter label::before{font-family:'Material Icons';content:\"search\";font-size:24px;line-height:40px;width:50px;position:absolute;top:0px;left:-50px;text-align:center;line-height:1;width:30px;top:6px;left:-33px}.o-table .o-table-container .dataTables_filter input{outline:none;font-size:100%;width:100%;height:24px;margin:7px 0;padding:0px}.o-table .o-table-container .dataTables_filter input:focus{border-bottom-width:2px}.o-table .o-table-container .dataTables_wrapper{display:-webkit-flex;display:flex;-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;-webkit-flex-wrap:nowrap;-ms-flex-wrap:nowrap;flex-wrap:nowrap;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;-webkit-align-content:stretch;-ms-flex-line-pack:stretch;align-content:stretch;-webkit-align-items:stretch;-ms-flex-align:stretch;align-items:stretch;margin:0;width:100%;height:100%}.o-table .o-table-container .dataTables_top_wrapper{margin:4px 0px}.o-table .o-table-container .dataTables_top_wrapper{display:-ms-flexbox;display:-webkit-flex;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-flex-wrap:wrap;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-justify-content:center;-ms-flex-pack:center;justify-content:center;-webkit-align-content:center;-ms-flex-line-pack:center;align-content:center;-webkit-align-items:flex-start;-ms-flex-align:start;align-items:flex-start;-webkit-order:0;-ms-flex-order:0;order:0;-webkit-flex:0 1 auto;-ms-flex:0 1 auto;flex:0 1 auto;-webkit-align-self:auto;-ms-flex-item-align:auto;align-self:auto}.o-table .o-table-container .dataTables_top_wrapper .dt-buttons,.o-table .o-table-container .dataTables_top_wrapper .dataTables_options{-webkit-order:0;-ms-flex-order:0;order:0;-webkit-flex:0 1 auto;-ms-flex:0 1 auto;flex:0 1 auto;-webkit-align-self:auto;-ms-flex-item-align:auto;align-self:auto}.o-table .o-table-container .dataTables_top_wrapper .dataTables_filter_wrapper{-webkit-order:0;-ms-flex-order:0;order:0;-webkit-flex:1 0 auto;-ms-flex:1 0 auto;flex:1 0 auto;-webkit-align-self:auto;-ms-flex-item-align:auto;align-self:auto}.o-table .o-table-container .dataTables_fill_remaining{-webkit-order:0;-ms-flex-order:0;order:0;-webkit-flex:1 1 auto;-ms-flex:1 1 auto;flex:1 1 auto;-webkit-align-self:auto;-ms-flex-item-align:auto;align-self:auto;-webkit-flex-direction:column;-ms-flex-direction:column;flex-direction:column;box-sizing:border-box;display:-webkit-box;display:-webkit-flex;display:-moz-box;display:-ms-flexbox;display:flex;margin:0;width:100%;height:100%}.o-table .o-table-container .dataTables_fill_remaining .o-table-scroll{overflow:auto;height:100%}.o-table .o-table-container .dataTables_pagination_wrapper{-webkit-order:0;-ms-flex-order:0;order:0;-webkit-flex:0 1 auto;-ms-flex:0 1 auto;flex:0 1 auto;-webkit-align-self:auto;-ms-flex-item-align:auto;align-self:auto}.o-table .o-table-container table{width:100.0%;margin:0;border-spacing:0;overflow:hidden;table-layout:fixed}.o-table .o-table-container table.small thead tr{height:32px}.o-table .o-table-container table.small tbody tr{height:28px}.o-table .o-table-container table.medium thead tr{height:40px}.o-table .o-table-container table.medium tbody tr{height:36px}.o-table .o-table-container table.small .o-table-column.o-table-column-action md-icon,.o-table .o-table-container table.medium .o-table-column.o-table-column-action md-icon{font-size:18px;line-height:22px}.o-table .o-table-container table.large thead tr{height:52px}.o-table .o-table-container table.large tbody tr{height:48px}.o-table .o-table-container table thead tr{height:56px}.o-table .o-table-container table thead tr th{position:relative;font-size:14px;font-weight:700;vertical-align:middle;text-align:center;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;min-width:42px;outline:none}.o-table .o-table-container table thead tr th:last-child:not(.o-table-column-action){padding:0 42px 0 24px !important}.o-table .o-table-container table thead tr th:first-child:not(.o-table-column-select-checkbox){padding:0 42px 0 54px !important}.o-table .o-table-container table thead tr th:first-child.o-table-column-select-checkbox{padding:0 12px 0 12px !important}.o-table .o-table-container table thead tr th:nth-child(2){padding:0 42px 0 24px !important}.o-table .o-table-container table thead tr th:nth-child(n+3):nth-last-child(n+2):not(.o-table-column-action){padding:0 42px 0 24px !important}.o-table .o-table-container table thead tr th.o-table-select-checkbox{width:20px;padding:0 0 0 24px}.o-table .o-table-container table thead tr th.sorting,.o-table .o-table-container table thead tr th.sorting_asc,.o-table .o-table-container table thead tr th.sorting_desc{cursor:pointer}.o-table .o-table-container table thead tr th.sorting::before,.o-table .o-table-container table thead tr th.sorting_asc::before,.o-table .o-table-container table thead tr th.sorting_desc::before,.o-table .o-table-container table thead tr th.sorting_asc_disabled::before,.o-table .o-table-container table thead tr th.sorting_desc_disabled::before{right:20px;font-family:'Material Icons';content:\"arrow_upward\";position:absolute;display:block;font-size:16px;font-weight:normal}.o-table .o-table-container table thead tr th.sorting::after,.o-table .o-table-container table thead tr th.sorting_asc::after,.o-table .o-table-container table thead tr th.sorting_desc::after,.o-table .o-table-container table thead tr th.sorting_asc_disabled::after,.o-table .o-table-container table thead tr th.sorting_desc_disabled::after{right:8px;font-family:'Material Icons';content:\"arrow_downward\";position:absolute;font-size:16px;font-weight:normal}.o-table .o-table-container table thead tr th.sorting_disabled::before,.o-table .o-table-container table thead tr th.sorting_disabled::after{opacity:0.5}.o-table .o-table-container table thead tr th div.sorting-index{position:absolute;top:28px;right:2px;font-weight:normal;font-size:10px}.o-table .o-table-container table thead tr th.group{text-decoration:underline}.o-table .o-table-container table thead tr th.o-table-column-action{padding:0 18px 0 18px !important}.o-table .o-table-container table thead tr th.o-table-column-action:last-child{padding-right:24px !important}.o-table .o-table-container table tbody tr{transition:background-color .2s;height:48px}.o-table .o-table-container table tbody tr.empty{height:0px !important}.o-table .o-table-container table tbody tr.group td{font-weight:bold}.o-table .o-table-container table tbody tr.group td:last-child{padding:0 16px !important}.o-table .o-table-container table tbody tr.group td .image-avatar{margin:0px}.o-table .o-table-container table tbody tr.group+tr td{border:none}.o-table .o-table-container table tbody tr.editRow input:not([type=\"checkbox\"]){top:3px;left:3px;bottom:3px;height:auto;width:90%}.o-table .o-table-container table tbody tr.editRow select{top:3px;left:3px;bottom:3px;height:auto;width:98%}.o-table .o-table-container table tbody tr.insertRow td input:not([type=\"checkbox\"]){top:3px;left:3px;bottom:3px;height:auto}.o-table .o-table-container table tbody tr.insertRow td select{top:3px;left:3px;bottom:3px;height:auto;width:98%}.o-table .o-table-container table tbody td{vertical-align:middle;text-align:left;font-size:13px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;position:relative;cursor:default}.o-table .o-table-container table tbody td.o-table-column-centered{text-align:center}.o-table .o-table-container table tbody td.focus{outline-offset:-1px}.o-table .o-table-container table tbody td.editable{cursor:text;cursor:cell}.o-table .o-table-container table tbody td.editing{outline-offset:-1px}.o-table .o-table-container table tbody td input{position:absolute;top:2px;left:2px;width:100%;height:100%;padding:0px 10px;border:none;outline:none}.o-table .o-table-container table tbody td select{position:absolute;top:-1px;left:1px;width:98%;height:100%;padding:0px 5px 0px 10px;border:none;outline:none}.o-table .o-table-container table tbody td input[type=\"checkbox\"]{height:14px;padding:0px;margin-left:0px}.o-table .o-table-container table tbody td:last-child:not(.o-table-column-action){padding:0 42px 0 24px !important}.o-table .o-table-container table tbody td:first-child:not(.o-table-column-action):not(.o-table-column-select-checkbox){padding:0 42px 0 54px !important}.o-table .o-table-container table tbody td:nth-child(2):not(.o-table-column-action){padding:0 42px 0 24px !important}.o-table .o-table-container table tbody td:nth-child(n+3):nth-last-child(n+2):not(.o-table-column-action){padding:0 42px 0 24px !important}.o-table .o-table-container table tbody td>div{max-height:48px}.o-table .o-table-container table tbody td.dataTables_empty{text-align:center;border-bottom-width:0px !important}.o-table .o-table-container table tbody td.o-table-column-boolean{text-align:center}.o-table .o-table-container table tbody td.o-table-column-string{text-align:left}.o-table .o-table-container table tbody td.o-table-column-number{text-align:right}.o-table .o-table-container table tbody td.o-table-column-date{text-align:center}.o-table .o-table-container table tbody td.o-table-column-image{text-align:center}.o-table .o-table-container table tbody td.o-table-column-action{text-align:center;padding:0px !important}.o-table .o-table-container table tbody td.o-table-column-action.focus{outline:none}.o-table .o-table-container table tbody td.o-table-column-action .o-table-row-action{text-transform:uppercase;text-decoration:underline;line-height:1;width:100%;cursor:pointer}.o-table .o-table-container table tbody td.o-table-column-action .o-table-row-action-edit-cancel,.o-table .o-table-container table tbody td.o-table-column-action .o-table-row-action-edit-save{width:50%;font-weight:bold;font-size:26px;cursor:pointer}.o-table .o-table-container table tbody td .image-plain{height:30px}.o-table .o-table-container table tbody td .image-plain img{max-width:100%;height:100%}.o-table .o-table-container table tbody td .image-avatar{width:34px;height:34px;margin:1px auto;overflow:hidden;border-radius:50%;position:relative;z-index:1}.o-table .o-table-container table tbody td .image-avatar img{position:absolute;top:50%;left:50%;-webkit-transform:translate(-50%, -50%);-moz-transform:translate(-50%, -50%);-ms-transform:translate(-50%, -50%);-o-transform:translate(-50%, -50%);transform:translate(-50%, -50%);width:100%;max-width:inherit;max-height:inherit}.o-table .o-table-container .noselect{-webkit-touch-callout:none;-webkit-user-select:none;-khtml-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.o-table .o-table-container .dataTables_length{float:right;margin:10px 10px 10px 0px;font-size:14px;line-height:22px}.o-table .o-table-container .dataTables_length select{border:none;margin-left:10px;outline:none}.o-table .o-table-container .dataTables_info{float:right;margin:10px 10px 10px 0px;font-size:14px;line-height:24px}.o-table .o-table-container .dataTables_info .select-info{position:absolute;left:20px;bottom:21px}.o-table .o-table-container .dataTables_paginate{float:right;margin:10px 10px 10px 0px;font-size:0px}.o-table .o-table-container .dataTables_paginate .paginate_button{visibility:hidden;cursor:pointer}.o-table .o-table-container .dataTables_paginate .paginate_button.first::after{font-family:'Material Icons';content:\"first_page\";visibility:visible;font-size:24px;margin:0px 5px}.o-table .o-table-container .dataTables_paginate .paginate_button.previous::after{font-family:'Material Icons';content:\"keyboard_arrow_left\";visibility:visible;font-size:24px;margin:0px 5px}.o-table .o-table-container .dataTables_paginate .paginate_button.next::after{font-family:'Material Icons';content:\"keyboard_arrow_right\";visibility:visible;font-size:24px;margin:0px 5px}.o-table .o-table-container .dataTables_paginate .paginate_button.last::after{font-family:'Material Icons';content:\"last_page\";visibility:visible;font-size:24px;margin:0px 5px}.o-table .o-table-container .dataTables_paginate .paginate_button.disabled{cursor:not-allowed}.o-table .o-table-menu-button{position:absolute;top:4px;right:0px}.o-table .o-table-menu-button .material-icons{top:7px;position:absolute;left:0;width:100%}div.dt-button-collection{position:absolute;top:0;left:0;min-width:200px;margin-top:3px;padding:12px 12px 8px 12px;border-radius:4px !important;box-shadow:0px 7px 8px -4px rgba(0,0,0,0.2),0px 13px 19px 2px rgba(0,0,0,0.14),0px 5px 24px 4px rgba(0,0,0,0.12);z-index:2002;-webkit-column-gap:8px;-moz-column-gap:8px;-ms-column-gap:8px;-o-column-gap:8px;column-gap:8px;overflow-y:auto;max-height:60%}div.dt-button-collection button.dt-button,div.dt-button-collection div.dt-button,div.dt-button-collection a.dt-button{position:relative;left:0;right:0;display:block;float:none;margin-bottom:8px;margin-right:0;text-decoration:none;line-height:34px;min-height:34px;font-size:14px;padding:0px 10px 0px 34px;outline:none}div.dt-button-collection a.dt-button:hover{border-radius:4px}div.dt-button-collection button.dt-button::before,div.dt-button-collection div.dt-button::before,div.dt-button-collection a.dt-button::before{font-family:'Material Icons';content:\"check_box_outline_blank\";font-size:18px;line-height:34px;position:absolute;left:8px}div.dt-button-collection button.dt-button:active:not(.disabled),div.dt-button-collection button.dt-button.active:not(.disabled),div.dt-button-collection div.dt-button:active:not(.disabled),div.dt-button-collection div.dt-button.active:not(.disabled),div.dt-button-collection a.dt-button:active:not(.disabled),div.dt-button-collection a.dt-button.active:not(.disabled){font-weight:bold}div.dt-button-collection button.dt-button:active:not(.disabled),div.dt-button-collection button.dt-button.active:not(.disabled)::before,div.dt-button-collection div.dt-button:active:not(.disabled)::before,div.dt-button-collection div.dt-button.active:not(.disabled)::before,div.dt-button-collection a.dt-button:active:not(.disabled)::before,div.dt-button-collection a.dt-button.active:not(.disabled)::before{font-family:'Material Icons';content:\"check_box\";font-size:18px;line-height:34px;position:absolute;left:8px}div.dt-button-collection.fixed{position:fixed;top:50%;left:50%;margin-left:-75px;border-radius:0}div.dt-button-collection.fixed.two-column{margin-left:-150px}div.dt-button-collection.fixed.three-column{margin-left:-225px}div.dt-button-collection.fixed.four-column{margin-left:-300px}div.dt-button-collection>*{-webkit-column-break-inside:avoid;break-inside:avoid}div.dt-button-collection.two-column{width:300px;padding-bottom:1px;-webkit-column-count:2;-moz-column-count:2;-ms-column-count:2;-o-column-count:2;column-count:2}div.dt-button-collection.three-column{width:450px;padding-bottom:1px;-webkit-column-count:3;-moz-column-count:3;-ms-column-count:3;-o-column-count:3;column-count:3}div.dt-button-collection.four-column{width:600px;padding-bottom:1px;-webkit-column-count:4;-moz-column-count:4;-ms-column-count:4;-o-column-count:4;column-count:4}div.dt-button-background{position:fixed;top:0;left:0;width:100%;height:100%;z-index:2001}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox::before,.o-table .o-table-container table thead tr th.o-table-column-select-checkbox::after{content:initial !important}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox,.o-table .o-table-container table tbody td.o-table-column-select-checkbox{text-align:center}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.focus,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.focus{outline:none}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox input[type=\"checkbox\"].select-row,.o-table .o-table-container table tbody td.o-table-column-select-checkbox input[type=\"checkbox\"].select-row{height:14px;width:14px;padding:0px;margin-left:0px;margin:0;-webkit-appearance:none;cursor:pointer;position:absolute;top:2px;left:2px}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-checked .mat-checkbox-inner-container .mat-checkbox-checkmark-path,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-checked .mat-checkbox-inner-container .mat-checkbox-checkmark-path{stroke-dashoffset:0}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-checked .mat-checkbox-inner-container .mat-checkbox-mixedmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-checked .mat-checkbox-inner-container .mat-checkbox-mixedmark{transform:scaleX(1) rotate(-45deg)}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-checked .mat-checkbox-inner-container .mat-checkbox-checkmark,.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-checked .mat-checkbox-inner-container .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-checked .mat-checkbox-inner-container .mat-checkbox-checkmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-checked .mat-checkbox-inner-container .mat-checkbox-background{opacity:1}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-indeterminate .mat-checkbox-inner-container .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-indeterminate .mat-checkbox-inner-container .mat-checkbox-background{opacity:1}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-indeterminate .mat-checkbox-inner-container .mat-checkbox-checkmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-indeterminate .mat-checkbox-inner-container .mat-checkbox-checkmark{opacity:0;transform:rotate(45deg)}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-indeterminate .mat-checkbox-inner-container .mat-checkbox-checkmark-path,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-indeterminate .mat-checkbox-inner-container .mat-checkbox-checkmark-path{stroke-dashoffset:0}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-indeterminate .mat-checkbox-inner-container .mat-checkbox-mixedmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-indeterminate .mat-checkbox-inner-container .mat-checkbox-mixedmark{opacity:1;transform:scaleX(1) rotate(0deg)}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container{display:inline-block;height:18px;line-height:0;margin:auto;order:0;position:relative;vertical-align:middle;white-space:nowrap;width:18px;cursor:pointer}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-frame,.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-background,.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-checkmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-frame,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-checkmark{bottom:0;left:0;position:absolute;right:0;top:0}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-frame,.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-frame,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-background{border-radius:2px;box-sizing:border-box;pointer-events:none}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-frame,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-frame{transition:border-color 140ms cubic-bezier(0, 0, 0.2, 0.1);will-change:border-color}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-background{align-items:center;opacity:0;display:inline-flex;justify-content:center;transition:background-color 140ms cubic-bezier(0, 0, 0.2, 0.1),opacity 140ms cubic-bezier(0, 0, 0.2, 0.1);will-change:background-color, opacity}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-checkmark,.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-mixedmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-checkmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-mixedmark{width:calc(100% - 4px)}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-checkmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-checkmark{width:100%}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-mixedmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-mixedmark{height:2.4px;opacity:0;transform:scaleX(0) rotate(0deg)}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-checkmark-path,.o-table .o-table-container table tbody td.o-table-column-select-checkbox .mat-checkbox-inner-container .mat-checkbox-checkmark-path{stroke-dashoffset:22.91026;stroke-dasharray:22.91026;stroke-width:2.4px}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-unchecked-checked .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-unchecked-checked .mat-checkbox-background{animation:280ms linear 0s mat-checkbox-fade-in-background}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-unchecked-checked .mat-checkbox-checkmark-path,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-unchecked-checked .mat-checkbox-checkmark-path{animation:280ms linear 0s mat-checkbox-unchecked-checked-checkmark-path}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-unchecked-indeterminate .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-unchecked-indeterminate .mat-checkbox-background{animation:280ms linear 0s mat-checkbox-fade-in-background}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-unchecked-indeterminate .mat-checkbox-mixedmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-unchecked-indeterminate .mat-checkbox-mixedmark{animation:140ms linear 0s mat-checkbox-unchecked-indeterminate-mixedmark}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-checked-unchecked .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-checked-unchecked .mat-checkbox-background{animation:280ms linear 0s mat-checkbox-fade-out-background}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-checked-unchecked .mat-checkbox-checkmark-path,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-checked-unchecked .mat-checkbox-checkmark-path{animation:140ms linear 0s mat-checkbox-checked-unchecked-checkmark-path}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-checked-indeterminate .mat-checkbox-checkmark .mat-checkbox-checkmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-checked-indeterminate .mat-checkbox-checkmark .mat-checkbox-checkmark{animation:140ms linear 0s mat-checkbox-checked-indeterminate-checkmark}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-checked-indeterminate .mat-checkbox-checkmark .mat-checkbox-mixedmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-checked-indeterminate .mat-checkbox-checkmark .mat-checkbox-mixedmark{animation:140ms linear 0s mat-checkbox-checked-indeterminate-mixedmark}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-indeterminate-checked .mat-checkbox-checkmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-indeterminate-checked .mat-checkbox-checkmark{animation:500ms linear 0s mat-checkbox-indeterminate-checked-checkmark}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-indeterminate-checked .mat-checkbox-mixedmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-indeterminate-checked .mat-checkbox-mixedmark{animation:500ms linear 0s mat-checkbox-indeterminate-checked-mixedmark}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-indeterminate-unchecked .mat-checkbox-background,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-indeterminate-unchecked .mat-checkbox-background{animation:280ms linear 0s mat-checkbox-fade-out-background}.o-table .o-table-container table thead tr th.o-table-column-select-checkbox.mat-checkbox-anim-indeterminate-unchecked .mat-checkbox-mixedmark,.o-table .o-table-container table tbody td.o-table-column-select-checkbox.mat-checkbox-anim-indeterminate-unchecked .mat-checkbox-mixedmark{animation:300ms linear 0s mat-checkbox-indeterminate-unchecked-mixedmark}@keyframes mat-checkbox-fade-in-background{0%{opacity:0}50%{opacity:1}}@keyframes mat-checkbox-fade-out-background{0%,50%{opacity:1}100%{opacity:0}}@keyframes mat-checkbox-unchecked-checked-checkmark-path{0%,50%{stroke-dashoffset:22.91026}50%{animation-timing-function:cubic-bezier(0, 0, 0.2, 0.1)}100%{stroke-dashoffset:0}}@keyframes mat-checkbox-unchecked-indeterminate-mixedmark{0%,68.2%{transform:scaleX(0)}68.2%{animation-timing-function:cubic-bezier(0, 0, 0, 1)}100%{transform:scaleX(1)}}@keyframes mat-checkbox-checked-unchecked-checkmark-path{from{animation-timing-function:cubic-bezier(0.4, 0, 1, 1);stroke-dashoffset:0}to{stroke-dashoffset:-22.91026}}@keyframes mat-checkbox-checked-indeterminate-checkmark{from{animation-timing-function:cubic-bezier(0, 0, 0.2, 0.1);opacity:1;transform:rotate(0deg)}to{opacity:0;transform:rotate(45deg)}}@keyframes mat-checkbox-indeterminate-checked-checkmark{from{animation-timing-function:cubic-bezier(0.14, 0, 0, 1);opacity:0;transform:rotate(45deg)}to{opacity:1;transform:rotate(360deg)}}@keyframes mat-checkbox-checked-indeterminate-mixedmark{from{animation-timing-function:cubic-bezier(0, 0, 0.2, 0.1);opacity:0;transform:rotate(-45deg)}to{opacity:1;transform:rotate(0deg)}}@keyframes mat-checkbox-indeterminate-checked-mixedmark{from{animation-timing-function:cubic-bezier(0.14, 0, 0, 1);opacity:1;transform:rotate(0deg)}to{opacity:0;transform:rotate(315deg)}}@keyframes mat-checkbox-indeterminate-unchecked-mixedmark{0%{animation-timing-function:linear;opacity:1;transform:scaleX(1)}32.8%,100%{opacity:0;transform:scaleX(0)}}.o-table table.fixedHeader-floating{position:fixed !important;z-index:200;left:initial !important}.o-table table.fixedHeader-floating.no-footer{border-bottom-width:0}.o-table table.fixedHeader-locked{position:absolute !important;z-index:200}@media print{table.fixedHeader-floating{display:none}}\n  "],
                    providers: [
                        { provide: OntimizeService, useFactory: dataServiceFactory, deps: [Injector] }
                    ],
                    inputs: DEFAULT_INPUTS_O_DATATABLE,
                    outputs: DEFAULT_OUTPUTS_O_DATATABLE,
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '[class.o-table]': 'true',
                        '[class.o-datatable]': 'true',
                        '[class.ontimize-table]': 'true'
                    }
                },] },
    ];
    ODataTableComponent.ctorParameters = function () { return [
        { type: Injector, },
        { type: ElementRef, },
        { type: OFormComponent, decorators: [{ type: Optional }, { type: Inject, args: [forwardRef(function () { return OFormComponent; }),] },] },
    ]; };
    ODataTableComponent.propDecorators = {
        'menuTrigger': [{ type: ViewChild, args: [MdMenuTrigger,] },],
    };
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "editOnFocus", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "quickFilter", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "deleteButton", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "refreshButton", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "columnsVisibilityButton", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "columnsResizeButton", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "columnsGroupButton", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "exportButton", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "insertTable", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "showTableButtonsText", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "selectAllCheckbox", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "singlePageMode", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODataTableComponent.prototype, "paginationControls", void 0);
    return ODataTableComponent;
}(OServiceComponent));
export { ODataTableComponent };
var ODataTableComponentModule = (function () {
    function ODataTableComponentModule() {
    }
    ODataTableComponentModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        ODataTableComponent,
                        ODataTableColumnComponent,
                        ODataTableCellRendererActionComponent,
                        ODataTableCellRendererBooleanComponent,
                        ODataTableCellRendererCurrencyComponent,
                        ODataTableCellRendererDateComponent,
                        ODataTableCellRendererImageComponent,
                        ODataTableCellRendererIntegerComponent,
                        ODataTableCellRendererRealComponent,
                        ODataTableCellRendererServiceComponent,
                        ODataTableCellRendererStringComponent,
                        ODataTableCellEditorBooleanComponent,
                        ODataTableCellEditorComboComponent,
                        ODataTableCellEditorDateComponent,
                        ODataTableCellEditorIntegerComponent,
                        ODataTableCellEditorRealComponent,
                        ODataTableCellEditorStringComponent,
                        ODataTableButtonComponent,
                        ODataTableOptionComponent,
                        ODataTableCellEditorDateDialog
                    ],
                    imports: [
                        OSharedModule,
                        CommonModule,
                        ODateInputModule,
                        OFormModule,
                        RouterModule
                    ],
                    entryComponents: [ODataTableCellEditorDateDialog],
                    exports: [
                        ODataTableComponent,
                        ODataTableColumnComponent,
                        ODataTableCellRendererActionComponent,
                        ODataTableCellRendererBooleanComponent,
                        ODataTableCellRendererCurrencyComponent,
                        ODataTableCellRendererDateComponent,
                        ODataTableCellRendererImageComponent,
                        ODataTableCellRendererIntegerComponent,
                        ODataTableCellRendererRealComponent,
                        ODataTableCellRendererServiceComponent,
                        ODataTableCellRendererStringComponent,
                        ODataTableCellEditorBooleanComponent,
                        ODataTableCellEditorComboComponent,
                        ODataTableCellEditorDateComponent,
                        ODataTableCellEditorIntegerComponent,
                        ODataTableCellEditorRealComponent,
                        ODataTableCellEditorStringComponent,
                        ODataTableButtonComponent,
                        ODataTableOptionComponent
                    ]
                },] },
    ];
    ODataTableComponentModule.ctorParameters = function () { return []; };
    return ODataTableComponentModule;
}());
export { ODataTableComponentModule };
//# sourceMappingURL=o-datatable.component.js.map